{$O+,F+}
Unit Main_Ovr;
Interface
Uses sn_Obj;

Procedure snDone;

Procedure About;
Procedure AltF10Pressed;
Procedure CtrlF10Pressed;
Procedure CtrlKPressed(var p:TPanel);
Procedure CtrlF1Pressed;
Procedure CtrlF2Pressed;
Procedure CtrlLPressed;
Procedure CtrlBPressed(x,y:byte);

function  snChooseDrive(w:byte):char;
function  CQuestion (quest:string; lan:byte):boolean;
Procedure PutSmallWindow(ts:string; bs:string);

function  GetWildMask(tit,curentmask:string):string;

Procedure SaveDesktop(fn:string);
Procedure LoadDesktop(fn:string);
Procedure Setup;
Procedure ViewHistoryCommands;
Procedure HistoryCommand;
Procedure DoExec(CmdStr:string; look:boolean);

{Procedure CtrlUPressed;{}


Implementation
Uses
     crc32c,Crt, Dos, RV, Inyan, Clock, Mouse,
     Vars, Main, sn_Mem, Palette, Utils,
     PC;


{============================================================================}
Procedure snDone;
Var PT:byte;
Begin
if SaveOnExit then
 begin
{$I-}
  WriteProfile(startdir+'\sn.ini','System','ASCn',strr(ASCln));
  WriteProfile(startdir+'\sn.ini','Interface','LColumns',strr(lp.Columns));
  WriteProfile(startdir+'\sn.ini','Interface','RColumns',strr(rp.Columns));
{$I+}
 end;

if Clocked then ClockExitProc;
TextAttr:=SavedAttr; RestCur; RestBkDesk; FreeMemPCDirs; MemDeskDone;
CurOn;
{ChDir(StartDir);{}
Halt(0);
End;



{============================================================================}
procedure About;
var y:byte;
begin
CurOff; Colour(7,15); if Moused then MouseOff; y:=halfmaxy;
sPutWin(10,y-8,70,y+8);
cmCentre(7,15,y-7,'ZX Spectrum Navigator');
cmCentre(7,15,y-6,'Version '+ver+' <free kernel>');
cmCentre(7,15,y-5,'Copyright (c) 1997-99 RomanRoms Software Co.');
if lang=rus then cmCentre(7,15,y-4,'.  த.')
            else cmCentre(7,15,y-4,'Russia. Nizhny Novgorod.');
if lang=rus then cmCentre(7,0,y+1,'-    ZX Spectrum?')
            else cmCentre(7,0,y+1,'- Do you have ZX Spectrum?');
if lang=rus then cmCentre(7,0,y+2,'-       FIDOnet?')
            else cmCentre(7,0,y+2,'- Do you have node in the FIDOnet?');
if lang=rus then cmCentre(7,0,y+3,'-  ᠭ   ZX.SPECTRUM?')
            else cmCentre(7,0,y+3,'- Do you receive echomail ZX.SPECTRUM?');
if lang=rus then cmCentre(7,0,y+5,'  ')
            else cmCentre(7,0,y+5,'So you are legal user of this programm.');
if lang=rus then cmCentre(7,15,y+6,' 짮⥫')
            else cmCentre(7,15,y+6,'');
if lang=rus then cmCentre(7,0,y+7,'⮩ ணࠬ.')
            else cmCentre(7,0,y+7,'Powered by Borland Pascal 7.01');
cmCentre(7,15,y-3, '     ');
cmCentre(7,15,y-2,'     ');
cmCentre(7,15,y-1,'     ');
if gMaxY<=30 then if Clocked then ClockExitProc;
if gMaxY<=30 then InyanOn(38,y-3);{}
if Moused then MouseOn;
rPause;
if gMaxY<=30 then InyanOff;{}
if gMaxY<=30 then if Clocked then Initialise;
RestScr;
PutCmdLine;
end;



{============================================================================}
Procedure AltF10Pressed;
begin
if Moused then MouseOff;
if gmaxy=30 then set80x25 else set80x30; curoff; flash(off);
GlobalRedraw;
SetMouseRange(1,1,gmaxx*8-1,gmaxy*8-1);
if Moused then MouseOn;
end;



{============================================================================}
Procedure CtrlF10Pressed;
begin
if Moused then MouseOff;
if gmaxy=25 then set80x50 else set80x25; curoff; flash(off);
GlobalRedraw;
SetMouseRange(1,1,gmaxx*8-1,gmaxy*8-1);
if Moused then MouseOn;
end;



{============================================================================}
Procedure CtrlKPressed(var p:TPanel);
Begin
if p.Columns<>1 then
 Begin
  p.clLastPanelType:=p.Columns;
  p.Columns:=1;
  p.Build('12');
  p.Info('A');
 End
else
 Begin
  p.Columns:=p.clLastPanelType;
  if p.Columns=0 then p.Columns:=3;
  p.Build('12');
  p.Info('A');
 End;
End;



{============================================================================}
Procedure CtrlF1Pressed;
Begin
if lp.PanelType=noPanel then
 Begin
  lp.PanelType:=lp.LastPanelType;
  lp.Build('012');
  reInfo('cbdnsfi');
  lp.pcPDF(lp.pcfrom);
  rePDF;
  snKernelExitCode:=11;
 End
else
 Begin
  lp.LastPanelType:=lp.PanelType;
  lp.PanelType:=noPanel;
  lp.Hide;
  snKernelExitCode:=10;
 End;
End;



{============================================================================}
Procedure CtrlF2Pressed;
Begin
if rp.PanelType=noPanel then
 Begin
  rp.PanelType:=rp.LastPanelType;
  rp.Build('012');
  reInfo('cbdnsfi');
  rePDF;
  snKernelExitCode:=21;
 End
else
 Begin
  rp.LastPanelType:=rp.PanelType;
  rp.PanelType:=noPanel;
  rp.Hide;
  snKernelExitCode:=20;
 End;
End;





{============================================================================}
Procedure CtrlLPressed;
Begin
Case focus of
 left:
   BEGIN
    if rp.PanelType<>noPanel then if rp.PanelType<>infPanel then
     Begin
      rp.clLastPanelType:=rp.PanelType;
      rp.PanelType:=infPanel;
      rp.Build('0');
      rp.Info('ci');
      Case lp.PanelType of
       pcPanel:
         BEGIN
          pcInfoPanel(left);
         END;
      End;
     End
    else
     Begin
      rp.PanelType:=rp.clLastPanelType;
      if (rp.Paneltype>=1)and(rp.Paneltype<=10) then rp.Build('012');
      reInfo('cbdnsfi');
      rePDF;
      snKernelExitCode:=21;
     End;
   END;
 right:
   BEGIN
    if lp.PanelType<>noPanel then if lp.PanelType<>infPanel then
     Begin
      lp.clLastPanelType:=lp.PanelType;
      lp.PanelType:=infPanel;
      lp.Build('0');
      lp.Info('ci');

      Case rp.PanelType of
       pcPanel:
         BEGIN
          pcInfoPanel(right);
         END;
      End;
     End
    else
     Begin
      lp.PanelType:=lp.clLastPanelType;
      if (lp.Paneltype>=1)and(lp.Paneltype<=10) then lp.Build('012');
      reInfo('cbdnsfi');
      rePDF;
      snKernelExitCode:=21;
     End;
   END;
End;
End;




{============================================================================}
Procedure CtrlBPressed(x,y:byte);
Var
   k:char; n:byte;
Begin
if ASCIITable(x,y,lang,ASCln,k,n) then command:=command+k;
ASCln:=n;
End;




{============================================================================}
{============================================================================}
{================== 롨ࠥ 㭪   ==================================}
{============================================================================}
{============================================================================}
function snChooseItem:byte;
var
   f,inttemp,fr,a:integer;
   la:word; lx,ly:integer;
   temp:integer;
   st:string;
   i,p:integer;
label loop;
{----------------------------------------------------------------------------}
Procedure PutItems;
var f:byte; v,k:integer;
Begin
if menu_visible>menu_total then v:=menu_total else v:=fr+menu_visible-1;
k:=1;
for f:=fr to v do
 begin
  if f<>menu_f then
    if menu_title=''
      then StatusLineColor(menu_bkNT,menu_txtNT,menu_bkST,menu_txtST,
                           menu_posx+2, menu_posy+k, '  '+menu_name[f]+'  ')
      else StatusLineColor(menu_bkNT,menu_txtNT,menu_bkST,menu_txtST,
                           menu_posx+2, menu_posy+k+2, '  '+menu_name[f]+'  ')
              else
    if menu_title=''
      then StatusLineColor(menu_bkMarkNT,menu_txtMarkNT,menu_bkMarkST,menu_txtMarkST,
                           menu_posx+2, menu_posy+k, '  '+menu_name[f]+'  ')
      else StatusLineColor(menu_bkMarkNT,menu_txtMarkNT,menu_bkMarkST,menu_txtMarkST,
                           menu_posx+2, menu_posy+k+2, '  '+menu_name[f]+'  ');
  inc(k);
 end;
End;
{----------------------------------------------------------------------------}
begin
if Moused then MouseOff;
la:=textattr; lx:=wherex; ly:=wherey;
if menu_bkNT<0 then      menu_bkNT     :=LightGray;
if menu_txtNT<0 then     menu_txtNT    :=Black;

if menu_bkST<0 then      menu_bkST     :=LightGray;
if menu_txtST<0 then     menu_txtST    :=White;

if menu_bkMarkNT<0 then  menu_bkMarkNT :=Blue;
if menu_txtMarkNT<0 then menu_txtMarkNT:=LightCyan;

if menu_bkMarkST<0 then  menu_bkMarkST :=Blue;
if menu_txtMarkST<0 then menu_txtMarkST:=White;

if menu_visible=255 then menu_visible:=round(gmaxy/3);
if menu_visible>menu_total then menu_visible:=menu_total;
if (menu_visible<=0)or(menu_visible>gmaxy-9) then menu_visible:=gmaxy-9;
if (menu_f<1)or(menu_f>menu_total) then menu_f:=1;
inttemp:=CCLen(menu_name[1]);
for f:=2 to menu_total do if CCLen(menu_name[f])>inttemp then inttemp:=CCLen(menu_name[f]);
if length(menu_title)>inttemp then inttemp:=length(menu_title);
if menu_posx=255 then menu_posx:=(halfmaxx)-round((6+inttemp)/2);
if menu_title<>'' then a:=2 else a:=2;
if menu_posy=255 then menu_posy:=round(halfmaxy-menu_visible/2)-a;
for f:=1 to menu_total do menu_name[f]:=menu_name[f]+space(inttemp-CCLen(menu_name[f]));
if menu_visible>menu_total then f:=menu_total else f:=menu_visible;
if menu_title=''
then
 scputwin(menu_bkNT,menu_txtNT,menu_posx, menu_posy, menu_posx+inttemp+7, menu_posy+f+1)
else
  begin
   scputwin(menu_bkNT,menu_txtNT,menu_posx, menu_posy, menu_posx+inttemp+7, menu_posy+f+3);
   if w_twosided
   then cmprint(menu_bkNT,menu_txtNT,menu_posx, menu_posy+2, chr(199)+fill(inttemp+6,#196)+chr(182))
   else cmprint(menu_bkNT,menu_txtNT,menu_posx, menu_posy+2, chr(195)+fill(inttemp+6,#196)+chr(180));
   cmprint(menu_bkNT,menu_txtNT,(menu_posx+round((inttemp+8)/2))-round((length(menu_title))/2), menu_posy+1, menu_title);
  end;
fr:=1;
loop:
  PutItems;
  if Moused then MouseOn;
  menu_kod:=readkey;

  if upcase(menu_kod) in ['A'..'Z'] then
   begin
    for temp:=1 to menu_total do
     begin
      if menu_name[temp][3]=upcase(menu_kod) then
       begin
        restscr;
        snChooseItem:=temp;
        textattr:=la;
        gotoxy(lx,ly);
        menu_posx:=255; menu_posy:=255;
        exit;
       end;
     end;
   end;
  if menu_kod=#13 then
   begin
    restscr;
    snChooseItem:=menu_f;
    textattr:=la;
    gotoxy(lx,ly);
    menu_posx:=255; menu_posy:=255;
    exit;
   end;
  if menu_kod=#27 then
   begin
    restscr;
    snChooseItem:=0;
    menu_posx:=255; menu_posy:=255;
    exit;
   end;
  if menu_kod=#0 then
   begin
    menu_kod:=readkey;
    if menu_kod=kb_End then
     begin
      restscr;
      snChooseItem:=0;
      menu_posx:=255; menu_posy:=255;
      exit;
     end;
    if (menu_kod=#80)or(menu_kod=#77) then
     begin
      inc(menu_f);
      if menu_f>fr+menu_visible-1 then begin inc(fr); if fr>menu_total-menu_visible+1 then dec(fr); end;
     end;
    if (menu_kod=#72)or(menu_kod=#75) then
     begin
      dec(menu_f);
      if menu_f<fr then begin dec(fr); if fr<1 then inc(fr); end;
     end;
   end;
  if menu_f>menu_total then menu_f:=menu_total;
  if menu_f<1 then menu_f:=1;

if Moused then MouseOff;
goto loop;
end;




{============================================================================}
function snChooseDrive(w:byte):char;
var ll,r,s,t:string; i:integer; k,d:char; loc,sub:boolean; a,b:byte; l:longint;

label loop;
begin
r:='';

whatflopp(a,b);
if a<>0 then r:=r+'A';
if b<>0 then r:=r+'B';
{}
r:=r+getalldrivers; s:='';
{r:='ABCDEFGHIJKLMNOPQRSTUVWXYZ';{}
menu_total:=length(r);
if lang=rus then menu_title:='' else menu_title:='Disk';
for i:=1 to length(r) do
 begin
  k:=r[i]; isdrivevalid(k,loc,sub);
  if sub then s:='Subst' else if loc then s:='Local' else s:='NetWork';
  if itcdrom(k) then s:='CD-ROM';
  if k='A' then
   begin
    if a=1 then begin s:='~`'+k+':~` Floppy'; if not ShotDiskMenu then s:=s+'  360k'; end;
    if a=2 then begin s:='~`'+k+':~` Floppy'; if not ShotDiskMenu then s:=s+'  1.2k'; end;
    if a=3 then begin s:='~`'+k+':~` Floppy'; if not ShotDiskMenu then s:=s+'  720k'; end;
    if a=4 then begin s:='~`'+k+':~` Floppy'; if not ShotDiskMenu then s:=s+'  1.44k'; end;
   end;
  if k='B' then
   begin
    if b=1 then begin s:='~`'+k+':~` Floppy'; if not ShotDiskMenu then s:=s+'  360k'; end;
    if b=2 then begin s:='~`'+k+':~` Floppy'; if not ShotDiskMenu then s:=s+'  1.2k'; end;
    if b=3 then begin s:='~`'+k+':~` Floppy'; if not ShotDiskMenu then s:=s+'  720k'; end;
    if b=4 then begin s:='~`'+k+':~` Floppy'; if not ShotDiskMenu then s:=s+'  1.44k'; end;
   end;

  if (s[3]<>'A')and(s[3]<>'B') then
   begin
    t:='~`'+k+':~` '+s+space(7-CCLen(s));
    if not ShotDiskMenu then
     begin
      t:=t+' ';
      l:=disksize(byte(k)-64);
      if l>1000 then begin ll:=strr(l div 1000); d:='K'; end;
      if l>1000000 then begin ll:=strr(l div 1000000); d:='M'; end;
      if l>1000000000 then begin ll:=strr(l div 1000000000)+','+copy(strr(l-1000000000*(l div 1000000000)),1,1); d:='G'; end;
{      if l>1000 then begin ll:=strr(l div 1000)+','+strr(l-(l div 1000)); d:='T'; end;{}
      if l>=0 then t:=t+ll+d else t:=t+'none';
      t:=t+space(17-CCLen(t))+getvolname(byte(k)-64);
     end;
   end else t:=s;

  menu_name[i]:=t;
 end;

if w=left then k:=lp.pcnd[1] else k:=rp.pcnd[1];
for menu_f:=1 to length(r) do if r[menu_f]=upcase(k) then break;

if w=right then menu_posx:=42 else menu_posx:=2;
menu_posy:=3; menu_visible:=maxy-12;
if ShotDiskMenu then inc(menu_posx,5);
i:=snchooseitem; if i=0 then begin snchoosedrive:='0'; exit; end;
snchoosedrive:=r[i];
end;





{============================================================================}
{== COLOR QESTION ===========================================================}
{============================================================================}
function  CQuestion (quest:string; lan:byte):boolean;
var
   k:char;
   cm,m,a,b:integer;
   x1,x2,dx:byte;
   yes,no,s:string;
label l;
begin
CurOff;
if lan=rus then
 begin yes:='      '; no:= '     '; end
else
 begin yes:='  Yes   '; no:= '   No   '; end;
cm:=halfmaxy;
if length(quest)<5 then dx:=5 else dx:=0;
x1:=halfmaxx-20;
x2:=halfmaxx+21;
if Moused then MouseOff;
Colour(bkdRama,txtdRama); sPutWin(x1,cm-4,x2,cm+3);
if lan=rus then
cmcentre(bkdRama,txtdRama,cm-4,' ⢥p ')
else cmcentre(bkdRama,txtdRama,cm-4,' Confirmation ');

if length(quest)<>length(without(quest,#255)) then
 begin
  CStatusLineColor(bkdStatic,txtdStatic,txtdStatic,cm-2,copy(quest,1,pos(#255,quest)));
  CStatusLineColor(bkdStatic,txtdStatic,txtdStatic,cm-1,copy(quest,pos(#255,quest)+1,255));
 end
else
 CStatusLineColor(bkdStatic,txtdStatic,txtdStatic,cm-2,quest);

colour(bkdRama,0);
m:=1;
{if Moused then MouseOn;{}

l:
 if m=1 then
  begin
   cbutton(bkdButtonA,txtdButtonA,bkdButtonShadow,txtdButtonShadow,halfmaxx-9,cm+1,yes,true);
   cbutton(bkdButtonNA,txtdButtonNA,bkdButtonShadow,txtdButtonShadow,halfmaxx+3,cm+1,no,false);
  end
 else
  begin
   cbutton(bkdButtonNA,txtdButtonNA,bkdButtonShadow,txtdButtonShadow,halfmaxx-9,cm+1,yes,false);
   cbutton(bkdButtonA,txtdButtonA,bkdButtonShadow,txtdButtonShadow,halfmaxx+3,cm+1,no,true);
  end;
if moused then MouseOn;
 k:=ReadKey;
 if k=#27 then begin CQuestion:=false; RestScr; Exit; end;
 if k=#13 then begin if m=0 then CQuestion:=false else CQuestion:=true; RestScr; Exit; end;
 if k=#0 then
  begin
   k:=ReadKey;
   if k=#77 then m:=0;
   if k=#75 then m:=1;
  end;
if moused then MouseOff;
goto l;
end;





{============================================================================}
function GetWildMask(tit,curentmask:string):string;
var newmask:string;
begin
 colour(bkdRama,txtdRama);
 scputwin(bkdRama,txtdRama,29,halfmaxy-4,52,halfmaxy+3);
 cmcentre(bkdRama,txtdRama,halfmaxy-4,tit);
 colour(bkdLabelNT,txtdLabelNT);

 if lang=rus then cmprint(bkdLabelST,txtdLabelST,33,halfmaxy-2,'c')
             else cmprint(bkdLabelST,txtdLabelST,33,halfmaxy-2,'Mask');
 cbutton(bkdButtonA,txtdButtonA,bkdButtonShadow,txtdButtonShadow,36,halfmaxy+1,'    OK    ',true);

 colour(bkdInputNT,txtdInputNT);
 curon;
 newmask:=scanf(32,halfmaxy-1,curentmask,18,18,pos('.',CurentMask)+1);
 curoff;
 restscr;
 if scanf_esc then GetWildMask:=curentmask else GetWildMask:=newmask;

end;


{============================================================================}
Procedure PutSmallWindow(ts:string; bs:string);
Begin
Colour(bkdRama,txtdRama);
scPutWin(bkdRama,txtdRama,29,halfmaxy-4,52,halfmaxy+3);
cmCentre(bkdRama,txtdRama,halfmaxy-4,ts);
Colour(bkdLabelNT,txtdLabelNT);
cButton(bkdButtonA,txtdButtonA,bkdButtonShadow,txtdButtonShadow,36,halfmaxy+1,bs,true)
End;





{============================================================================}
Procedure SaveDesktop(fn:string);
Var
    s:string; b:byte; i:integer;
    ff:file; buf:array[1..3072] of byte;
procedure Add2BufStr(ind:word; str:string);
var w:word;
begin
for w:=1 to length(str) do buf[ind+w-1]:=ord(str[w]);
end;

Begin
for i:=1 to 3072 do buf[i]:=0;
Add2BufStr(1,'SN Desktop');
buf[11]:=lp.Columns; buf[12]:=rp.Columns;
buf[13]:=lp.InfoLines; buf[14]:=rp.InfoLines;
if lp.NameLine then buf[15]:=1 else buf[15]:=0;
if rp.NameLine then buf[16]:=1 else buf[16]:=0;
s:=lp.pcnn+space(12-length(lp.pcnn)); Add2BufStr(17,s);
s:=rp.pcnn+space(12-length(rp.pcnn)); Add2BufStr(29,s);
s:=lp.pcnd+space(128-length(lp.pcnd)); Add2BufStr(41,s);
s:=rp.pcnd+space(128-length(rp.pcnd)); Add2BufStr(169,s);
buf[297]:=lp.PanelType; buf[298]:=rp.PanelType;
buf[299]:=lp.LastPanelType; buf[300]:=rp.LastPanelType;
buf[301]:=lp.clLastPanelType; buf[302]:=rp.clLastPanelType;
buf[303]:=lp.SortType; buf[304]:=rp.SortType;

buf[305]:=lo(lp.tdirs); buf[306]:=hi(lp.tdirs);
buf[307]:=lo(rp.tdirs); buf[308]:=hi(rp.tdirs);
buf[309]:=lo(lp.tfiles); buf[310]:=hi(lp.tfiles);
buf[311]:=lo(rp.tfiles); buf[312]:=hi(rp.tfiles);

buf[313]:=lo(lp.from); buf[314]:=hi(lp.from);
buf[315]:=lo(rp.from); buf[316]:=hi(rp.from);
buf[317]:=lo(lp.f); buf[318]:=hi(lp.f);
buf[319]:=lo(rp.f); buf[320]:=hi(rp.f);
{}
buf[321]:=lo(lp.pcfrom); buf[322]:=hi(lp.pcfrom);
buf[323]:=lo(rp.pcfrom); buf[324]:=hi(rp.pcfrom);
buf[325]:=lo(lp.pcf); buf[326]:=hi(lp.pcf);
buf[327]:=lo(rp.pcf); buf[328]:=hi(rp.pcf);

buf[329]:=lp.ckLastPanelType; buf[330]:=rp.ckLastPanelType;

buf[765]:=focus; buf[766]:=gmaxy;
buf[767]:=length(command);
s:=command+space(255-length(command)); Add2BufStr(768,s);


{$I-}
assign(ff,fn); rewrite(ff,1); blockwrite(ff,buf,1024); close(ff);
{$I+}
if IOResult<>0 then
 if lang=rus then errormessage(' ࠭ ﭨ')
             else errormessage('Can'#39't save settings');

End;



{============================================================================}
Procedure LoadDesktop(fn:string);
Var
    s:string; b:byte; i:integer;
    ff:file; buf:array[1..3072] of byte;
function GetBufStr(ind,l:word):string;
var w:word;
begin
s:='';
for w:=1 to l do s:=s+chr(buf[ind+w-1]);
GetBufStr:=s;
end;

Begin
{$I-}
assign(ff,fn); reset(ff,1); blockread(ff,buf,1024); close(ff);
{$I+}
if ioresult<>0 then exit;
s:=GetBufStr(1,10); if s<>'SN Desktop' then exit;

lp.Columns:=buf[11]; rp.Columns:=buf[12];
lp.InfoLines:=buf[13]; rp.InfoLines:=buf[14];
if buf[15]=1 then lp.NameLine:=true else lp.NameLine:=false;
if buf[16]=1 then rp.NameLine:=true else rp.NameLine:=false;
lp.pcnn:=nospaceLR(GetBufStr(17,12));
rp.pcnn:=nospaceLR(GetBufStr(29,12));
lp.pcnd:=nospaceLR(GetBufStr(41,128));
rp.pcnd:=nospaceLR(GetBufStr(169,128));


lp.PanelType:=buf[297]; rp.PanelType:=buf[298];
lp.LastPanelType:=buf[299]; rp.LastPanelType:=buf[300];
lp.clLastPanelType:=buf[301]; rp.clLastPanelType:=buf[302];
lp.ckLastPanelType:=buf[329]; rp.ckLastPanelType:=buf[330];
lp.SortType:=buf[303]; rp.SortType:=buf[304];

lp.tdirs   :=256*buf[306]+buf[305]; rp.tdirs   :=256*buf[308]+buf[307];
lp.tfiles  :=256*buf[310]+buf[309]; rp.tfiles  :=256*buf[312]+buf[311];
{}
lp.from    :=256*buf[314]+buf[313]; rp.from    :=256*buf[316]+buf[315];
lp.f       :=256*buf[318]+buf[317]; rp.f       :=256*buf[320]+buf[319];
{}
lp.pcfrom  :=256*buf[322]+buf[321]; rp.pcfrom  :=256*buf[324]+buf[323];
lp.pcf     :=256*buf[326]+buf[325]; rp.pcf     :=256*buf[328]+buf[327];

focus:=buf[765];
b:=buf[766];
if RestoreVideo then
 Begin
  Case b of
   25: if gmaxy<>25 then Set80x25;
   30: if gmaxy<>30 then Set80x30;
   50: if gmaxy<>50 then Set80x50;
  End;
 End;
command:=nospaceLR(GetBufStr(768,255));{}
if nospace(command)='' then command:='';

End;




{============================================================================}
Procedure Setup;
Var Stemp:string;
Begin
  if lang=rus then stemp:=' ccﭨ?' else stemp:='Save curent settings?';
  if cquestion(stemp,lang) then savedesktop(StartDir+'\sn.dsk') else putcmdline;

  reMDF;
  reTrueCur;
  reInside;
  reInfo('cbdnsfi');
  rePDF;
End;




{============================================================================}
Procedure ViewHistoryCommands;
var i:byte;
begin
menu_total:=0;
for i:=1 to 32 do
 begin
  if History[i]='end of history' then break;
  menu_name[i]:=History[i];
  inc(menu_total);
 end;
if menu_total=0 then exit;
menu_visible:=gmaxy-5;
menu_f:=menu_total; if lang=rus then menu_title:=' ' else menu_title:='Command history';
i:=ChooseItem;
if i<>0 then
 begin
  command:=nospaceLR(menu_name[i]);
  CommandXFrom:=255; CommandXPos:=255;
 end;
end;




{============================================================================}
Procedure HistoryCommand;
Var
f:text; a:array[1..32] of string[128]; i,m:byte;
Begin
 {$I-}
 assign(f,startdir+'\sn.his');
 if CheckDirFile(startdir+'\sn.his')<>0 then
  begin filemode:=2; rewrite(f); writeln(f,'SN History file'); close(f); end;

 filemode:=0; reset(f);
 readln(f,a[1]); i:=1;
 repeat
  readln(f,a[i]);
  inc(i);
  if (i>30)or(EOF(f)) then break;
 until false;
 close(f);

 if i>30 then
  begin
   filemode:=2; rewrite(f); writeln(f,'SN History file');
   for m:=2 to 30 do writeln(f,a[m]);
   close(f);
  end;

 filemode:=2; append(f);
 writeln(f,command);
 close(f);
 {$I+}
 if IOResult<>0 then;
End;


{============================================================================}
Procedure DoExec(CmdStr:string; look:boolean);
var
stemp:string; ndir:string;
f:text; a:array[1..30] of string[128]; i,m:word;
Begin
 if clocked then clockexitproc;
 textattr:=savedattr; restbkdesk; restcur; curon; MemDeskDone; FreeMemPCDirs; {savetextmode;{}

 ndir:=pcndOf(focus);
 if (length(ndir)>3)and(ndir[length(ndir)]='\') then stemp:=copy(ndir,1,length(ndir)-1) else stemp:=ndir;
 SaveDesktop(TempDir+'\'+GetOf(startnum,_name)+'.swp');
 {$I-} chdir(stemp); {$I+}
 colour(0,7);
 if look then
  begin
   if wherex<>1 then writeln;
   writeln(ndir+cmdstr);
  end;
 halt(1);
End;





{============================================================================}
{
Procedure CtrlUPressed;
var lpp,rpp:TPanel; i:word;
begin
lpp:=lp; rpp:=rp;

lp.PanelLong:=rpp.PanelLong; rp.PanelLong:=lpp.PanelLong;
lp.PanelHi:=rpp.PanelHi; rp.PanelHi:=lpp.PanelHi;
lp.Columns:=rpp.Columns; rp.Columns:=lpp.Columns;
lp.InfoLines:=rpp.InfoLines; rp.InfoLines:=lpp.InfoLines;
lp.PutFrom:=rpp.PutFrom; rp.PutFrom:=lpp.PutFrom;
lp.NameLine:=rpp.NameLine; rp.NameLine:=lpp.NameLine;
lp.Visible:=rpp.Visible; rp.Visible:=lpp.Visible;
lp.PanelType:=rpp.PanelType; rp.PanelType:=lpp.PanelType;
lp.clLastPanelType:=rpp.clLastPanelType; rp.clLastPanelType:=lpp.clLastPanelType;
lp.ckLastPanelType:=rpp.ckLastPanelType; rp.ckLastPanelType:=lpp.ckLastPanelType;
lp.ckLastPanelType:=rpp.ckLastPanelType; rp.ckLastPanelType:=lpp.ckLastPanelType;
lp.xc:=rpp.xc; rp.xc:=lpp.xc;
lp.yc:=rpp.yc; rp.yc:=lpp.yc;
lp.lc:=rpp.lc; rp.lc:=lpp.lc;
lp.tdirs:=rpp.tdirs; rp.tdirs:=lpp.tdirs;
lp.tfiles:=rpp.tfiles; rp.tfiles:=lpp.tfiles;
lp.from:=rpp.from; rp.from:=lpp.from;
lp.f:=rpp.f; rp.f:=lpp.f;
lp.pcnd:=rpp.pcnd; rp.pcnd:=lpp.pcnd;
lp.oldpcnd:=rpp.oldpcnd; rp.oldpcnd:=lpp.oldpcnd;
lp.pcnn:=rpp.pcnn; rp.pcnn:=lpp.pcnn;
lp.TreeC:=rpp.TreeC; rp.TreeC:=lpp.TreeC;
lp.SortType:=rpp.SortType; rp.SortType:=lpp.SortType;
lp.pctdirs:=rpp.pctdirs; rp.pctdirs:=lpp.pctdirs;
lp.pctfiles:=rpp.pctfiles; rp.pctfiles:=lpp.pctfiles;
lp.pctfiles:=rpp.pctfiles; rp.pctfiles:=lpp.pctfiles;
lp.oldpctfiles:=rpp.oldpctfiles; rp.oldpctfiles:=lpp.oldpctfiles;
lp.trdtfiles:=rpp.trdtfiles; rp.trdtfiles:=lpp.trdtfiles;
lp.taptfiles:=rpp.taptfiles; rp.taptfiles:=lpp.taptfiles;
lp.fditfiles:=rpp.fditfiles; rp.fditfiles:=lpp.fditfiles;
lp.fddtfiles:=rpp.fddtfiles; rp.fddtfiles:=lpp.fddtfiles;
lp.zxztfiles:=rpp.zxztfiles; rp.zxztfiles:=lpp.zxztfiles;
lp.scltfiles:=rpp.scltfiles; rp.scltfiles:=lpp.scltfiles;
lp.trdnn:=rpp.trdnn; rp.trdnn:=lpp.trdnn;
lp.fdinn:=rpp.fdinn; rp.fdinn:=lpp.fdinn;
lp.fddnn:=rpp.fddnn; rp.fddnn:=lpp.fddnn;
lp.tapnn:=rpp.tapnn; rp.tapnn:=lpp.tapnn;
lp.sclnn:=rpp.sclnn; rp.sclnn:=lpp.sclnn;
lp.zxznn:=rpp.zxznn; rp.zxznn:=lpp.zxznn;
lp.pcf:=rpp.pcf; rp.pcf:=lpp.pcf;
lp.pcfrom:=rpp.pcfrom; rp.pcfrom:=lpp.pcfrom;
lp.trdfrom:=rpp.trdfrom; rp.trdfrom:=lpp.trdfrom;
lp.trdf:=rpp.trdf; rp.trdf:=lpp.trdf;
lp.fdifrom:=rpp.fdifrom; rp.fdifrom:=lpp.fdifrom;
lp.fdif:=rpp.fdif; rp.fdif:=lpp.fdif;
lp.tapfrom:=rpp.tapfrom; rp.tapfrom:=lpp.tapfrom;
lp.tapf:=rpp.tapf; rp.tapf:=lpp.tapf;
lp.fddfrom:=rpp.fddfrom; rp.fddfrom:=lpp.fddfrom;
lp.fddf:=rpp.fddf; rp.fddf:=lpp.fddf;
lp.zxzfrom:=rpp.zxzfrom; rp.zxzfrom:=lpp.zxzfrom;
lp.zxzf:=rpp.zxzf; rp.zxzf:=lpp.zxzf;
lp.sclfrom:=rpp.sclfrom; rp.sclfrom:=lpp.sclfrom;
lp.sclf:=rpp.sclf; rp.sclf:=lpp.sclf;
lp.trdFile:=rpp.trdFile; rp.trdFile:=lpp.trdFile;
lp.tapFile:=rpp.tapFile; rp.tapFile:=lpp.tapFile;
lp.fdiFile:=rpp.fdiFile; rp.fdiFile:=lpp.fdiFile;
lp.fddFile:=rpp.fddFile; rp.fddFile:=lpp.fddFile;
lp.zxzFile:=rpp.zxzFile; rp.zxzFile:=lpp.zxzFile;
lp.sclFile:=rpp.sclFile; rp.sclFile:=lpp.sclFile;

ChangeFocus;
reMDF;

lp.Build('12'); rp.Build('12');
reInfo('A');
rePDF;
end;
{}


Begin
sBar[rus,noPanel]:='~`Alt+X~` 室'; sBar[eng,noPanel]:='~`Alt+X~` Exit';
sBar[rus,infPanel]:='~`Alt+X~` 室'; sBar[eng,infPanel]:='~`Alt+X~` Exit';
End.