{$O+,F+}
Unit TRD;
Interface
Uses
     Dos,Crt,RV,sn_Obj, Vars, Palette, Main, Main_Ovr,
     PC,PC_Ovr;
Var
     less:byte;

function  trdNameLine(var p:TPanel; a:word):string;
function  bpos(tr,sc:byte):longint;

function  et(n:longint; lang:byte):string; {஦}
Procedure trdInfoPanel(w:byte);

function  isTRD(path:string):boolean;

function  TRDOSe3(var p:TPanel; i:integer):string;
function  TRDOSe31(var p:TPanel; i:integer):string;
function  hiTRDOSe3:string;
function  hiTRDOSe31:string;
procedure trdMDF(var p:TPanel; path:string);
procedure trdPDF(var p:TPanel; fr:integer);
function  eb(n:longint; lang:byte):string;   {, 䠩}
function  itHobeta(name:string; var rec:hobrec):boolean;

Procedure snCopier(flag:word; SourcePanel,DestPanel:byte);
Procedure snEraser(var p:TPanel);
Procedure snPacker(var p:TPanel);

Procedure zxViewFile(var p:TPanel);


Implementation
Uses
     FDI,FDI_Ovr,SCL,SCL_Ovr,FDD,FDD_Ovr,TAP,TAP_Ovr,TRD_Ovr,ZXZIP;

{============================================================================}
function trdNameLine(var p:TPanel; a:word):string;
var nm,stemp:string;
begin
           p.trdnn:=p.trddir^[a].name+'.'+TRDOSe31(p,a);
           nm:=p.trddir^[a].name+' '+TRDOSe3(p,a);
           stemp:=extnum(strr(p.trddir^[a].start)); stemp:=changechar(stemp,' ',',');
           nm:=nm+space(9-length(stemp))+stemp;

           stemp:=extnum(strr(p.trddir^[a].length)); stemp:=changechar(stemp,' ',',');
           nm:=nm+space(9-length(stemp))+stemp;

           stemp:=strr(p.trddir^[a].totalsec);
           stemp:='('+space(4-length(stemp))+stemp+')';

           nm:=nm+space(8-length(stemp))+stemp;
trdNameLine:=nm;
end;




{============================================================================}
function bpos(tr,sc:byte):longint;
var a,b,c,d,s:longint;
begin
s:=0;
a:=4096;
b:=tr*a;
s:=s+b;
c:=256;
d:=sc*c;
s:=s+d;
bpos:=s;
end;



{============================================================================}
function et(n:longint; lang:byte):string; {஦}
var
   i:longint;
begin
i:=n div 10; i:=i*10; i:=n-i;
if lang=rus then
 begin
  case i of
   0: et:='';
   1: et:='';
   2: et:='';
   3: et:='';
   4: et:='';
   5: et:='';
   6: et:='';
   7: et:='';
   8: et:='';
   9: et:='';
  end;
  if n=11 then et:='';
  if n=12 then et:='';
  if n=13 then et:='';
  if n=14 then et:='';
 end
else
 begin
  if n=1 then et:='' else et:='s';
 end;
end;






{============================================================================}
Procedure trdInfoPanel(w:byte);
var
     a,b:byte; s,s0:string; i,m,l:longint; k:char; posx,posy,panellong:byte;
     trks,pt,treec:byte; zxlabel,trdfile,pcnd:string; free,trddfiles,trdtfiles:word;
     p:TPanel;
begin

Case w of
 left:
   BEGIN
    p:=lp;
    trks:=lp.zxdisk.tracks;
    pt:=lp.PanelType;
    posx:=rp.posx;
    posy:=rp.posy;
    panellong:=rp.panellong;
    treec:=lp.treec;
    pcnd:=lp.pcnd;
    Case pt of
     trdPanel: trdfile:=lp.trdfile;
     fdiPanel: trdfile:=lp.fdifile;
     fddPanel: trdfile:=lp.fddfile;
     sclPanel: trdfile:=lp.sclfile;
     tapPanel: trdfile:=lp.tapfile;
     zxzPanel: trdfile:=lp.zxzfile;
    End;
    zxlabel:=lp.zxdisk.disklabel;
    trdtfiles:=lp.zxdisk.files;
    trddfiles:=lp.zxdisk.delfiles;
    free:=lp.zxdisk.free;
   END;
 right:
   BEGIN
    p:=rp;
    trks:=rp.zxdisk.tracks;
    pt:=rp.PanelType;
    posx:=lp.posx;
    posy:=lp.posy;
    panellong:=lp.panellong;
    treec:=rp.treec;
    pcnd:=rp.pcnd;
    Case pt of
     trdPanel: trdfile:=rp.trdfile;
     fdiPanel: trdfile:=rp.fdifile;
     fddPanel: trdfile:=rp.fddfile;
     sclPanel: trdfile:=rp.sclfile;
     tapPanel: trdfile:=rp.tapfile;
     zxzPanel: trdfile:=rp.zxzfile;
    End;
    zxlabel:=rp.zxdisk.disklabel;
    trdtfiles:=rp.zxdisk.files;
    trddfiles:=rp.zxdisk.delfiles;
    free:=rp.zxdisk.free;
   END;
End;

cmPrint(bkRama,txtRama,posx,posy+PanelLong-2,''+space(38)+'');
cmPrint(bkRama,txtRama,posx,posy+PanelLong-1,''+fill(38,'')+'');

Case pt of
 trdPanel: if lang=rus then s0:='騩 TRD-䠩:' else s0:='Current TRD-file:';
 fdiPanel: if lang=rus then s0:='騩 FDI-䠩:' else s0:='Current FDI-file:';
 fddPanel: if lang=rus then s0:='騩 FDD-䠩:' else s0:='Current FDD-file:';
 sclPanel: if lang=rus then s0:='騩 SCL-䠩:' else s0:='Current SCL-file:';
 tapPanel: if lang=rus then s0:='騩 TAP-䠩:' else s0:='Current TAP-file:';
 zxzPanel: if lang=rus then s0:='騩 ZXZIP-䠩:' else s0:='Current ZXZIP-file:';
End;

i:=19-(length(without(s0,'~`'))div 2); if i<0 then i:=0;
s:=space(i)+s0; s:=s+space(abs(38-CClen(s))); if CClen(s)>38 then delete(s,39+8,10);
StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,2,s);{}

s0:=nospace(trdfile);
if length(s0)>29 then s0:=copy(s0,1,4)+'...'+copy(s0,length(s0)-22,30);
s:='~`'+s0+'~`';
s0:=s;
i:=19-(length(without(s0,'~`'))div 2); if i<0 then i:=0;
s:=space(i)+s0; s:=s+space(abs(38-CClen(s))); if CClen(s)>38 then delete(s,39+8,10);
StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,3,s);{}

StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,4,space(38));

i:=trks;
if lang=rus then s:='(~`'+changechar(extnum(strr(filelen(trdfile))),' ',',')+'~` )'
            else s:='(~`'+changechar(extnum(strr(filelen(trdfile))),' ',',')+'~` bytes)';
if (p.PanelType=trdPanel)or(p.PanelType=fdiPanel)or(p.PanelType=fddPanel) then
 Begin
  if lang=rus then s:='~`'+strr(i)+'~` ஦'+et(i,rus)+' '+s
              else s:='~`'+strr(i)+'~` track'+et(i,lang)+' '+s;
 End;
s0:=s;
i:=19-(length(without(s0,'~`'))div 2); if i<0 then i:=0;
s:=space(i)+s0; s:=s+space(abs(38-CClen(s))); if CClen(s)>38 then delete(s,39+8,10);
StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,5,s);

StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,6,space(38));

s:='';
s0:=s;
i:=19-(length(without(s0,'~`'))div 2); if i<0 then i:=0;
s:=space(i)+s0; s:=s+space(abs(38-CClen(s))); if CClen(s)>38 then delete(s,39+8,10);
StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,7,s);

StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,8,space(38));

if lang=rus then s:=' ᪠: ~`'+nospaceLR(zxlabel)
            else s:='Disk name: ~`'+nospaceLR(zxlabel);
s0:=s;
i:=19-(length(without(s0,'~`'))div 2); if i<0 then i:=0;
s:=space(i)+s0; s:=s+space(abs(38-CClen(s))); if CClen(s)>38 then delete(s,39+8,10);
StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,9,s);

if lang=rus then s:=' ᥣ - ~`'+strr(trdtfiles)+'~`, 㤠 - ~`'+strr(trddfiles)
            else s:='Total files - ~`'+strr(trdtfiles)+'~`, deleted - ~`'+strr(trddfiles);
s0:=s;
i:=19-(length(without(s0,'~`'))div 2); if i<0 then i:=0;
s:=space(i)+s0; s:=s+space(abs(38-CClen(s))); if CClen(s)>38 then delete(s,39+8,10);
StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,10,s);

StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,11,space(38));

if lang=rus then s:='~`'+strr(free)+'~` '+eb(free,rus)+' ᢮'
            else s:='~`'+strr(free)+'~` block'+eb(free,lang)+' free';
s0:=s;
i:=19-(length(without(s0,'~`'))div 2); if i<0 then i:=0;
s:=space(i)+s0; s:=s+space(abs(38-CClen(s))); if CClen(s)>38 then delete(s,39+8,10);
StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,12,s);

StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,13,space(38));

s:='';
s0:=s;
i:=19-(length(without(s0,'~`'))div 2); if i<0 then i:=0;
s:=space(i)+s0; s:=s+space(abs(38-CClen(s))); if CClen(s)>38 then delete(s,39+8,10);
StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,14,s);

StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,15,space(38));

if (p.PanelType<>sclPanel)and(p.PanelType<>tapPanel) then
 BEGIN
  for i:=1 to p.trdtfiles+1 do if p.trddir^[i].name+'.'+p.trddir^[i].typ='boot    .B' then break;
  if i>p.trdtfiles then
   begin
    if lang=rus then s:=' ~`boot.<B>~` '
                else s:='File ~`boot.<B>~` not present';
    s0:=s;
    i:=19-(length(without(s0,'~`'))div 2); if i<0 then i:=0;
    s:=space(i)+s0; s:=s+space(abs(38-CClen(s))); if CClen(s)>38 then delete(s,39+8,10);
    StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,16,s);
   end else
StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,16,space(38));
 END else
StatusLineColor(bkDiskInfoNT,txtDiskInfoNT,bkDiskInfoST,txtDiskInfoST,posx+1,16,space(38));

end;


{============================================================================}
function isTRD(path:string):boolean;
var fb:file of byte;
    b:byte;
    i:integer;
label fin,fin2;
begin
isTRD:=false;
{$I-}
filemode:=0;
assign(fb,path); reset(fb);
seek(fb,$8e3); read(fb,b); if not (b in [$16,$17,$18,$19]) then goto fin;
seek(fb,$8e4); read(fb,b); if not (b in [0..128]) then goto fin;{}
seek(fb,$8e7); read(fb,b); if not (b in [$10]) then goto fin;
isTRD:=true;
fin:
close(fb);
{$I+}
fin2:
if ioresult<>0 then;
end;
{============================================================================}
{============================================================================}
{============================================================================}
{============================================================================}
{============================================================================}
{============================================================================}



{============================================================================}
function TRDOSe3(var p:TPanel; i:integer):string;
var name:string;
begin
if TRDOS3 then
 name:=p.trdDir^[i].typ+chr(lo(p.trdDir^[i].start))+chr(hi(p.trdDir^[i].start))
          else
 name:='<'+p.trdDir^[i].typ+'>';
if p.trdDir^[i].typ='B' then name:='<'+p.trdDir^[i].typ+'>';
TRDOSe3:=name;
end;


{============================================================================}
function TRDOSe31(var p:TPanel; i:integer):string;
var name:string;
begin
if TRDOS3 then
 name:=p.trdDir^[i].typ+chr(lo(p.trdDir^[i].start))+chr(hi(p.trdDir^[i].start))
          else
 name:=p.trdDir^[i].typ;
if p.trdDir^[i].typ='B' then name:=p.trdDir^[i].typ;
TRDOSe31:=name;
end;


{============================================================================}
function hiTRDOSe3:string;
var name:string;
begin
if TRDOS3 then
 name:=HobetaInfo.typ+chr(lo(HobetaInfo.start))+chr(hi(HobetaInfo.start))
          else
 name:='<'+HobetaInfo.typ+'>';
if HobetaInfo.typ='B' then name:='<'+HobetaInfo.typ+'>';
hiTRDOSe3:=name;
end;


{============================================================================}
function hiTRDOSe31:string;
var name:string;
begin
if TRDOS3 then
 name:=HobetaInfo.typ+chr(lo(HobetaInfo.start))+chr(hi(HobetaInfo.start))
          else
 name:=HobetaInfo.typ;
if HobetaInfo.typ='B' then name:=HobetaInfo.typ;
hiTRDOSe31:=name;
end;



{============================================================================}
procedure trdMDF(var p:TPanel; path:string);
var
    fb:file of byte;
    i,k,trdinsed:integer;
    buf:array[1..16] of byte;
    s:string[8];
    b,b2:byte;
    stemp:string;
begin
if (checkdirfile(p.trdfile)<>0)or(not isTRD(p.trdfile)) then
 begin
  if lang=rus then errormessage('H  TRD 䠩')
              else errormessage('TRD file not found');
  p.PanelType:=pcPanel;
  p.pcMDF(p.pcnd);
  p.Inside;
  Exit;
 end;

k:=0; for i:=1 to p.trdtfiles do if p.trdDir^[i].mark then begin inc(k);
p.trdins^[k].crc16:=crc16(p.trddir^[i].name+TRDOSe3(p,i)); end; trdinsed:=k;

{$I-}
filemode:=0;
assign(fb,path); reset(fb);
p.zxdisk.tracks:=filelen(p.trdfile)div 8192;

seek(fb,$8e1); read(fb,b); p.zxdisk.n1freesec:=b;
seek(fb,$8e2); read(fb,b); p.zxdisk.ntr1freesec:=b;
seek(fb,$8e3); read(fb,b); p.zxdisk.disktyp:=b;
seek(fb,$8e4); read(fb,b); p.zxdisk.files:=b;
seek(fb,$8e5); read(fb,b); read(fb,b2); p.zxdisk.free:=b+256*b2;
seek(fb,$8e7); read(fb,b); p.zxdisk.trdoscode:=b;
seek(fb,$8f4); read(fb,b); p.zxdisk.delfiles:=b;
seek(fb,$8f5); stemp:=''; for i:=1 to 8 do begin read(fb,b); stemp:=stemp+chr(b); end;
p.zxdisk.disklabel:=stemp;

p.trdtfiles:=p.zxdisk.files; inc(p.trdtfiles);

p.trddir^[1].name:='<<      ';
p.trddir^[1].typ:='-';
p.trddir^[1].start:=0;
p.trddir^[1].length:=0;
p.trddir^[1].totalsec:=0;
p.trddir^[1].n1sec:=0;
p.trddir^[1].n1tr:=0;
p.trddir^[1].mark:=false;

for i:=1 to p.trdtfiles do
 begin
  seek(fb,16*(i-1));
  for k:=0 to 15 do read(fb,buf[k+1]);
  s:='';
  for k:=1 to 8 do s:=s+chr(buf[k]);
  p.trddir^[i+1].name:=s;
  p.trddir^[i+1].typ:=chr(buf[9]);
  p.trddir^[i+1].start:=buf[10]+256*buf[11];
  p.trddir^[i+1].length:=buf[12]+256*buf[13];
  p.trddir^[i+1].totalsec:=buf[14];
  p.trddir^[i+1].n1sec:=buf[15];
  p.trddir^[i+1].n1tr:=buf[16];
  p.trddir^[i+1].mark:=false;
 end;

close(fb);
{$I+}
if ioresult<>0 then;

for i:=1 to trdinsed do for k:=1 to p.trdtfiles do
if p.trdIns^[i].crc16=crc16(p.trddir^[k].name+TRDOSe3(p,k)) then p.trdDir^[k].mark:=true;
end;



{============================================================================}
procedure trdPDF(var p:TPanel; fr:integer);
var px,py,py0,ph,paper,ink,pp,ii,dx,ddx:byte;
    i,n:integer;
    s,name:string; e:string[3];
begin

if p.paneltype<>trdPanel then exit;

n:=p.trdtfiles;
if n>fr-1+p.panelhi*p.Columns then n:=fr-1+p.panelhi*p.Columns;
px:=p.posx+1; py:=p.putfrom;
Case p.Columns of 1: dx:=13; 2: dx:=19; 3: dx:=13; End;
for i:=fr to n do
 begin
  if (px=21)or(px=61) then ddx:=1 else ddx:=0;
  name:=p.trdDir^[i].name;
  if i=1
    then name:='<<'+space(dx+ddx-3)
    else name:=name+space((dx+ddx-5)-length(name))+' '+TRDOSe3(p,i);

  paper:=bkNT; ink:=txtNT;
  e:='<'+p.trdDir^[i].typ+'>';
  col(e,p.trdDir^[i].length,paper,ink);
  if (ord(p.trdDir^[i].name[1])=1)or(ord(p.trdDir^[i].name[1])=0) then begin paper:=bkg4; ink:=txtg4; end;
  if i=1 then begin paper:=bkdir; ink:=txtdir; end;
  pp:=paper; ii:=ink;
  if p.trddir^[i].mark then begin paper:=bkST; ink:=txtST; end;
  if p.focused and(i=p.from+p.f-1) then begin paper:=bkCurNT; ink:=txtCurNT; end;
  if p.focused and(i=p.from+p.f-1)and(p.trddir^[i].mark) then begin paper:=bkCurST; ink:=txtCurST; end;

  if p.trddir^[i].mark then name[(dx+ddx-4)]:=#251;

  cmprint(paper,ink,px,py,name);
  s:=space(25);
  if p.Columns=1 then
   begin
    cmprint(paper,ink,px+13,py,s); cmprint(paper,TxtRama,px+12,py,'');
   end;


  if ii=paper then ii:=ink;                                    {
  if p.focused and(i=p.from+p.f-1) then ii:=txtCurNT;
  if p.focused and(i=p.from+p.f-1)and(p.pcdir^[i].mark) then
    begin ii:=     ink; if ii=bkCurST then ii:=txtCurST; end;  {}
  PrintSelf(paper,ii,px+(dx+ddx-5),py,1);

  inc(py);
  if py>p.panelhi+p.putfrom-1 then begin py:=p.putfrom; inc(px,dx); end;
 end;

for i:=n+1 to p.panelhi*p.Columns do
 begin
  if (px=21)or(px=61) then ddx:=1 else ddx:=0;
  name:=space(dx+ddx-1);
  cmprint(bkNT,txtNT,px,py,name);
  if p.Columns=1 then
   begin
    cmprint(bkNT,txtNT,px+13,py,space(25)); cmprint(bkRama,TxtRama,px+12,py,'');
   end;
  inc(py);
  if py>p.panelhi+p.putfrom-1 then begin py:=p.putfrom; inc(px,dx); end;
 end;
end;




{============================================================================}
function eb(n:longint; lang:byte):string;   {, 䠩}
var
   i:longint; s:string;
begin
s:=(strr(n));
s:=s[length(s)-1]+s[length(s)];
i:=n div 10; i:=i*10; i:=n-i;
if lang=rus then
 begin
  case i of
   0: eb:='';
   1: eb:='';
   2: eb:='';
   3: eb:='';
   4: eb:='';
   5: eb:='';
   6: eb:='';
   7: eb:='';
   8: eb:='';
   9: eb:='';
  end;
  if n=11 then eb:='';
  if n=12 then eb:='';
  if n=13 then eb:='';
  if n=14 then eb:='';
  if vall(s)=11 then eb:='';
  if vall(s)=12 then eb:='';
  if vall(s)=13 then eb:='';
  if vall(s)=14 then eb:='';
 end
else
 begin
  if n=1 then eb:='' else eb:='s';
 end;
end;





{============================================================================}
function itHobeta(name:string; var rec:hobrec):boolean;
var
   i,a,b:byte;
   s,c:word;
   hob:array[0..16]of byte;
   fb:file of byte;
   temp:hobrec;
begin
{$I-}
ithobeta:=false;
if checkdirfile(name)<>0 then exit;
filemode:=0;
assign(fb,name); reset(fb); seek(fb,0); for i:=0 to 16 do read(fb,hob[i]); close(fb);
if ioresult<>0 then;
{$I+}

s:=0; for i:=0 to 14 do s:=s+257*hob[i]+i;
a:=hob[16]; b:=hob[15]; c:=256*a+b;
if c<>s then exit;
ithobeta:=true;

temp.name:=space(8);
for i:=0 to 7 do temp.name[i+1]:=chr(hob[i]);
temp.typ:=chr(hob[8]);
temp.start:=hob[9]+256*hob[10];
temp.length:=hob[11]+256*hob[12];
temp.param2:=hob[11]+256*hob[12];
if temp.typ<>'B' then temp.param2:=32768;
temp.totalsec:=hob[14];
rec:=temp;
end;






{============================================================================}
function noHobCopy(i:word; sp,dp:TPanel):boolean;
var totalsec:word; s:string;
{----------------------------------------------------------------------------}
function pscanf2(scanf_posx, scanf_posy:byte;
               scanf_str:string;
               scanf_total, scanf_visible,
               scanf_cur:byte):string;
var
     scanf_kod:char;
     scanf_x, scanf_from:byte;
     scanf_str_old:string;
label loop,loop2;
begin
scanf_esc:=false;
scanf_str_old:=scanf_str;
scanf_str:=scanf_str+space(scanf_total-length(scanf_str));
scanf_x:=scanf_cur;
scanf_from:=1;
if scanf_visible>length(scanf_str) then scanf_visible:=length(scanf_str);

loop:
mprint(scanf_posx,scanf_posy,copy(scanf_str,scanf_from,scanf_visible));
gotoxy(scanf_posx+scanf_x-scanf_from,scanf_posy);
scanf_kod:=readkey;
if scanf_kod=#27 then begin pscanf2:=scanf_str_old; scanf_esc:=true; exit; end;
if scanf_kod=#13 then
 begin
  if vall(nospace(scanf_str))>255 then Begin scanf_str:='255 '; scanf_x:=4; goto loop; End;
  if vall(nospace(scanf_str))<1 then   Begin scanf_str:='1   '; scanf_x:=2; goto loop; End;

  pscanf2:=scanf_str;
  exit;
 end;

if ((scanf_kod)>=' ')and((scanf_kod)<='')and(scanf_x<=length(scanf_str)) then
 begin
  {
  scanf_str:=copy(scanf_str,1,scanf_x-1)+scanf_kod+copy(scanf_str,scanf_x,length(scanf_str));
  scanf_str:=copy(scanf_str,1,length(scanf_str)-1);
  {}
  scanf_str[scanf_x]:=scanf_kod;
  inc(scanf_x);
  if scanf_x-scanf_from>scanf_visible then inc(scanf_from);
  if scanf_x>length(scanf_str)+1 then scanf_x:=length(scanf_str)+1;
 end;

if scanf_kod=#8 then
 begin
  scanf_str:=copy(scanf_str,1,scanf_x-2)+copy(scanf_str,scanf_x,length(scanf_str));
  dec(scanf_x);
  if scanf_x<scanf_from then dec(scanf_from);
  if scanf_x<1 then scanf_x:=1 else scanf_str:=scanf_str+' ';
  if scanf_from<1 then scanf_from:=1;
  if scanf_x<1 then scanf_x:=1;
 end;
{}
if scanf_kod=#25 then
 begin
  scanf_str:=space(scanf_total);
  scanf_from:=1;
  scanf_x:=1;
 end;

if scanf_kod=#0 then
 begin
  scanf_kod:=readkey;
  if scanf_kod=#71 then begin scanf_from:=1; scanf_x:=1; end;
  if scanf_kod=#79 then begin scanf_from:=scanf_total-scanf_visible+1; scanf_x:=length(nospaceLR(scanf_str))+1; end;
  if scanf_kod=#83 then scanf_str:=copy(scanf_str,1,scanf_x-1)+copy(scanf_str,scanf_x+1,length(scanf_str))+' ';{}
  if scanf_kod=#77 then
   begin
    inc(scanf_x);
    if scanf_x-scanf_from>scanf_visible then inc(scanf_from);
   end;
  if scanf_kod=#75 then
   begin
    dec(scanf_x);
    if scanf_x<scanf_from then dec(scanf_from);
   end;

  if scanf_from<1 then scanf_from:=1;
  if scanf_x<1 then scanf_x:=1;
  if scanf_x>length(scanf_str)+1 then begin scanf_x:=length(scanf_str)+1; dec(scanf_from); end;
  if scanf_posx+scanf_x>gmaxx then scanf_x:=gmaxx-scanf_posx;
 end;

goto loop;
end;
{----------------------------------------------------------------------------}
Var
    wtf:word; tff,ts1f:byte; l:longint; k,w:word;
    f:file;
Begin
noHobCopy:=false;
if itHobeta(pcndOf(focus)+TrueNameOf(focus,i),HobetaInfo) then exit;
if i<=sp.pctdirs then exit;

CancelSB; colour(bkdRama,txtdRama);
scputwin(bkdRama,txtdRama,23,halfmaxy-5,57,halfmaxy-3+6);
if lang=rus then cmcentre(bkdRama,txtdRama,halfmaxy-5,' ⢥ত ')
            else cmcentre(bkdRama,txtdRama,halfmaxy-5,' Confirmation ');
if lang=rus then StatusLineColor(bkdLabelST,txtdLabelST,bkdLabelNT,txtdLabelNT,27,halfmaxy-3,
                                 '஢ 审 䠩')
            else StatusLineColor(bkdLabelST,txtdLabelST,bkdLabelNT,txtdLabelNT,27,halfmaxy-3,
                                 'Copy not Hobeta file');
s:=(TrueNameOf(focus,i));
StatusLineColor(bkdLabelST,txtdLabelST,bkdLabelNT,txtdLabelNT,40-(length(s)div 2),halfmaxy-2,
                ''+s+'');
if lang=rus then StatusLineColor(bkdLabelST,txtdLabelST,bkdLabelNT,txtdLabelNT,27,halfmaxy-1,
                                 '       ᥪ஢')
            else StatusLineColor(bkdLabelST,txtdLabelST,bkdLabelNT,txtdLabelNT,27,halfmaxy-1,
                                 'blocks size of      sectors ');
colour(bkdLabelNT,txtdLabelNT);
cbutton(bkdButtonA,txtdButtonA,bkdButtonShadow,txtdButtonShadow,36,halfmaxy+1,'    OK    ',true);
colour(bkdInputNT,txtdInputNT); curon;
s:=strhi(nospace(pscanf2(42,halfmaxy-1,'255',4,4,1))); curoff; restscr;
ts1f:=vall(nospace(s));

if scanf_esc then exit;

totalsec:=sp.pcDir^[i].flength div 256; l:=totalsec; l:=256*l;
tff:=totalsec div ts1f;

if sp.pcDir^[i].flength-l>0 then inc(totalsec);

if (dp.PanelType=trdPanel)or(dp.PanelType=fddPanel)or(dp.PanelType=fdiPanel) then
if totalsec>dp.zxdisk.free then
 begin
  if lang=rus then errormessage('H c  c  ⮣ 䠩')
              else errormessage('Not enough space for this file');
  exit;
 end;

wtf:=totalsec div ts1f;
if totalsec-wtf*ts1f>0 then inc(wtf);

if dp.zxdisk.files+1>128 then
       begin
        if lang=rus then errormessage('C誮  䠩 㤥')
        else errormessage('It would be to many files');
        exit;
       end;
{$I-}
assign(f,sp.pcnd+sp.TrueName(i)); filemode:=0; reset(f,1);

w:=0;
for k:=1 to tff do
 Begin
  getmem(HobetaInfo.body,256*ts1f);

  blockRead(f,HobetaInfo.body^,256*ts1f);
  HobetaInfo.name:=strlo(sp.pcDir^[i].fname);
  s:=LZZ(w);
  if dp.PanelType=tapPanel then
   Begin
    HobetaInfo.name:=sRexpand(HobetaInfo.name,10);
    HobetaInfo.name[10]:=s[3];
    HobetaInfo.name[9]:=s[2];
    HobetaInfo.name[8]:=s[1];
   End
  else
   Begin
    HobetaInfo.name:=sRexpand(HobetaInfo.name,8);
    HobetaInfo.name[8]:=s[3];
    HobetaInfo.name[7]:=s[2];
    HobetaInfo.name[6]:=s[1];
   End;
  if TRDOS3 then
   Begin
    HobetaInfo.typ:=DnCase(sp.pcDir^[i].fext[1]);
    HobetaInfo.start:=ord(DnCase(sp.pcDir^[i].fext[2]))+256*ord(DnCase(sp.pcDir^[i].fext[3]));
   End
  else
   Begin
    HobetaInfo.typ:='C'; HobetaInfo.start:=HobetaStartAddr;
   End;
  HobetaInfo.totalsec:=ts1f;
  HobetaInfo.length:=256*ts1f;

  Case dp.PanelType of
   trdPanel: trdSave(dp);
   fdiPanel: fdiSave(dp);
   sclPanel: sclSave(dp);
   fddPanel: fddSave(dp);
   tapPanel: tapSave(dp);
   zxzPanel: zxzSave(dp);
  End;

  inc(w);
 End;

  HobetaInfo.totalsec:=totalsec-tff*ts1f;
  getmem(HobetaInfo.body,256*HobetaInfo.totalsec);
  for k:=1 to 256*HobetaInfo.totalsec do HobetaInfo.body^[k]:=0;
  blockRead(f,HobetaInfo.body^,65280);
  HobetaInfo.name:=strlo(sp.pcDir^[i].fname);
  s:=LZZ(w);
  if dp.PanelType=tapPanel then
   Begin
    HobetaInfo.name:=sRexpand(HobetaInfo.name,10);
    if w>0 then
     begin
      HobetaInfo.name[10]:=s[3];
      HobetaInfo.name[9]:=s[2];
      HobetaInfo.name[8]:=s[1];
     end;
   End
  else
   Begin
    HobetaInfo.name:=sRexpand(HobetaInfo.name,8);
    if w>0 then
     begin
      HobetaInfo.name[8]:=s[3];
      HobetaInfo.name[7]:=s[2];
      HobetaInfo.name[6]:=s[1];
     end;
   End;
  if TRDOS3 then
   Begin
    HobetaInfo.typ:=DnCase(sp.pcDir^[i].fext[1]);
    HobetaInfo.start:=ord(DnCase(sp.pcDir^[i].fext[2]))+256*ord(DnCase(sp.pcDir^[i].fext[3]));
   End
  else
   Begin
    HobetaInfo.typ:='C'; HobetaInfo.start:=HobetaStartAddr;
   End;
  HobetaInfo.length:=sp.pcDir^[i].flength-tff*(256*ts1f);

close(f);

  Case dp.PanelType of
   trdPanel: trdSave(dp);
   fdiPanel: fdiSave(dp);
   sclPanel: sclSave(dp);
   fddPanel: fddSave(dp);
   tapPanel: tapSave(dp);
   zxzPanel: zxzSave(dp);
  End;
{$I+}

if IOResult=0 then
 begin
  noHobCopy:=true; sp.pcDir^[i].mark:=false;
 end;

reMDF; reInfo('cbdnsfi'); rePDF;
End;



{============================================================================}
{
   for i:=1 to tDirsFilesOf(focus) do
    if (pcDirMarkOf(focus,i))and(itHobeta(pcndOf(focus)+TrueNameOf(focus,i),HobetaInfo))
    then else Case focus of left: lp.pcDir^[i].mark:=false; right: lp.pcDir^[i].mark:=false; end;
   reInfo('s'); rePDF;
}
Procedure snCopier(flag:word; SourcePanel,DestPanel:byte);
Var
    TargetPath:string;
    skip:boolean;
    i:word;
    loaded,saved,bool,UserOut:boolean;
Begin
 Case focus of
  left:  i:=lp.trdDir^[lp.Index].tapflag;
  right: i:=rp.trdDir^[rp.Index].tapflag;
 End;
 if (SourcePanel=tapPanel)and(DestPanel<>tapPanel)and(InsedOf(focus)=0)and(i=0) then exit;

 if WillCopyMove(flag,TargetPath,skip) then
  BEGIN

   if InsedOf(focus)=0 then
    if PanelTypeOf(focus)=pcPanel then
     Case focus of
      left:  lp.pcDir^[lp.Index].mark:=true;
      right: rp.pcDir^[rp.Index].mark:=true;
     End
    else
     Case focus of
      left:  lp.trdDir^[lp.Index].mark:=true;
      right: rp.trdDir^[rp.Index].mark:=true;
     End;

   less:=0;
   for i:=1 to tdirsfilesOf(focus) do
    begin
     if PanelTypeOf(focus)=pcPanel then bool:=pcDirMarkOf(focus,i) else bool:=trdDirMarkOf(focus,i);
     if bool then
      Begin

       Case focus of
        left:
          BEGIN
           loaded:=false;
           {What to LOAD?}
           Case SourcePanel of
            pcPanel:  if hobLoad(pcndOf(focus)+TrueNameOf(focus,i)) then loaded:=true;
            trdPanel: if trdLoad(lp,i) then loaded:=true;
            fdiPanel: if fdiLoad(lp,i) then loaded:=true;
            sclPanel: if sclLoad(lp,i) then loaded:=true;
            fddPanel: if fddLoad(lp,i) then loaded:=true;
            tapPanel: if tapLoad(lp,i) then loaded:=true;
            zxzPanel: if zxzLoad(lp,i) then loaded:=true;
           End;
           {What to SAVE?}
           if (not loaded)and(SourcePanel=pcPanel)and(DestPanel<>pcPanel) then noHobCopy(i,lp,rp);
           if loaded then
            Begin
             UserOut:=false;
     {-->}   if (DestPanel<1)or(DestPanel>10) then
              begin
               if CheckDir(TargetPath)<>0 then CreateDir(TargetPath);
               hobSave(TargetPath,AltF5Pressed);
              end;
     {-->}   if (DestPanel=trdPanel)or(DestPanel=fdiPanel)or(DestPanel=fddPanel) then
              Begin
               if rp.zxdisk.files+1>128 then
                 begin errormessage('誮  䠩'); UserOut:=true; end;
               if rp.zxdisk.free<HobetaInfo.totalsec then
                 begin errormessage(' '); UserOut:=true; end;
              End;
     {-->}   if DestPanel=sclPanel then
              Begin
               if rp.zxdisk.files+1>128 then
                 begin errormessage('誮  䠩'); UserOut:=true; end;
               if DiskFree(ord(UpCase(rp.sclfile[1]))-64)<256*HobetaInfo.totalsec then
                 begin errormessage(' '); UserOut:=true; end;
              End;
     {-->}   if DestPanel=tapPanel then
              Begin
               if rp.zxdisk.files+1>256 then
                 begin errormessage('誮  䠩'); UserOut:=true; end;
               if DiskFree(ord(UpCase(rp.tapfile[1]))-64)<HobetaInfo.length then
                 begin errormessage(' '); UserOut:=true; end;
              End;

             if not UserOut then Case DestPanel of
              pcPanel:
                BEGIN
                 if CheckDir(TargetPath)<>0 then CreateDir(TargetPath);
                 hobSave(TargetPath,AltF5Pressed);
                END;
              trdPanel: trdSave(rp);
              fdiPanel: fdiSave(rp);
              sclPanel: sclSave(rp);
              fddPanel: fddSave(rp);
              tapPanel: tapSave(rp);
              zxzPanel: zxzSave(rp);
             End else FreeMem(HobetaInfo.body,256*HobetaInfo.totalsec);
             if UserOut then break;
             lp.pcDir^[i].mark:=false; lp.trdDir^[i].mark:=false;
            End;
          END;
        right:
          BEGIN
           {What to LOAD?}
           loaded:=false;
           Case SourcePanel of
            pcPanel:  if hobLoad(pcndOf(focus)+TrueNameOf(focus,i)) then loaded:=true;
            trdPanel: if trdLoad(rp,i) then loaded:=true;
            fdiPanel: if fdiLoad(rp,i) then loaded:=true;
            sclPanel: if sclLoad(rp,i) then loaded:=true;
            fddPanel: if fddLoad(rp,i) then loaded:=true;
            tapPanel: if tapLoad(rp,i) then loaded:=true;
            zxzPanel: if zxzLoad(rp,i) then loaded:=true;
           End;
           {What to SAVE?}
           if (not loaded)and(SourcePanel=pcPanel)and(DestPanel<>pcPanel) then noHobCopy(i,rp,lp);
           if loaded then
            Begin
             UserOut:=false;
     {-->}   if (DestPanel<1)or(DestPanel>10) then
              begin
               if CheckDir(TargetPath)<>0 then CreateDir(TargetPath);
               hobSave(TargetPath,AltF5Pressed);
              end;
     {-->}   if (DestPanel=trdPanel)or(DestPanel=fdiPanel)or(DestPanel=fddPanel) then
              Begin
               if lp.zxdisk.files+1>128 then
                 begin errormessage('誮  䠩'); UserOut:=true; end;
               if lp.zxdisk.free<HobetaInfo.totalsec then
                 begin errormessage(' '); UserOut:=true; end;
              End;
     {-->}   if DestPanel=sclPanel then
              Begin
               if lp.zxdisk.files+1>128 then
                 begin errormessage('誮  䠩'); UserOut:=true; end;
               if DiskFree(ord(UpCase(lp.sclfile[1]))-64)<256*HobetaInfo.totalsec then
                 begin errormessage(' '); UserOut:=true; end;
              End;
     {-->}   if DestPanel=tapPanel then
              Begin
               if lp.zxdisk.files+1>256 then
                 begin errormessage('誮  䠩'); UserOut:=true; end;
               if DiskFree(ord(UpCase(lp.tapfile[1]))-64)<HobetaInfo.length then
                 begin errormessage(' '); UserOut:=true; end;
              End;

             if not UserOut then Case DestPanel of
              pcPanel:
                BEGIN
                 if CheckDir(TargetPath)<>0 then CreateDir(TargetPath);
                 hobSave(TargetPath,AltF5Pressed);
                END;
              trdPanel: trdSave(lp);
              fdiPanel: fdiSave(lp);
              sclPanel: sclSave(lp);
              fddPanel: fddSave(lp);
              tapPanel: tapSave(lp);
              zxzPanel: zxzSave(lp);
             End else FreeMem(HobetaInfo.body,256*HobetaInfo.totalsec);
             if UserOut then break;
             rp.pcDir^[i].mark:=false; rp.trdDir^[i].mark:=false;
            End;
          END;
       End;

       if refresh then reInfo('sf');

      End;
    end;
   reMDF; reTrueCur; lp.Inside; lp.Outside;  rp.Inside; rp.Outside;
   if focus=left then lp.Inside else rp.Inside;
   reInfo('cbdnsfi');  rePDF;
  END;
End;





{============================================================================}
procedure snEraser(var p:TPanel);
Var
    s:string;
Begin
if p.PanelType=zxzPanel then exit;

if (p.Insed=0)and(p.Index<=1) then exit;
if ((ord(p.trddir^[p.Index].name[1])=1)or(ord(p.trddir^[p.Index].name[1])=0))and(p.Insed=0) then exit;

if p.Insed=0 then s:=p.trddir^[p.Index].name+'.'+TRDOSe3(p,p.Index);
if p.Insed=1 then s:=p.trddir^[p.FirstMarked].name+'.'+TRDOSe3(p,p.FirstMarked);

if p.PanelType=tapPanel then
 Begin
  if (p.Insed=0)and(PanelTypeOf(oFocus)<>tapPanel)and(p.trdDir^[p.Index].tapflag=0) then exit;
  if p.Insed=0 then
   if PanelTypeOf(oFocus)=tapPanel
      then if p.trdDir^[p.Index].tapflag=0
              then s:=p.trdDir^[p.Index].name
              else s:='codes'
      else if p.Index>2
              then if p.trdDir^[p.Index-1].tapflag<>0
                      then s:='less'
                      else s:=p.trdDir^[p.Index-1].name
              else s:='less';

  if p.Insed=1 then
   if PanelTypeOf(oFocus)=tapPanel
      then if p.trdDir^[p.FirstMarked].tapflag=0
              then s:=p.trdDir^[p.FirstMarked].name
              else s:='codes'
      else if p.FirstMarked>2
              then if p.trdDir^[p.FirstMarked-1].tapflag<>0
                      then s:='less'
                      else s:=p.trdDir^[p.FirstMarked-1].name
              else s:='less';

  if PanelTypeOf(oFocus)=tapPanel then
   BEGIN
    if lang=rus
      then s:=' 㤠'#255' "'+s+'" ?'
      else s:='Do you wish to delete'#255'item "'+s+'" ?';

    if p.Insed>1 then if lang=rus then s:=' 㤠'#255'  ?'
                                  else s:='Do you wish to delete'#255'this items ?';
   END
  else
   BEGIN
    if lang=rus
      then s:=' 㤠'#255'䠩 "'+s+'" ?'
      else s:='Do you wish to delete'#255'file "'+s+'" ?';

    if p.Insed>1 then if lang=rus then s:=' 㤠'#255' 䠩 ?'
                                  else s:='Do you wish to delete'#255'this files ?';
  END;
 End
else
 Begin
  if lang=rus
    then s:=' 㤠'#255'䠩 "'+s+'" ?'
    else s:='Do you wish to delete'#255'file "'+s+'" ?';

  if p.Insed>1 then if lang=rus then s:=' 㤠'#255' 䠩 ?'
                                else s:='Do you wish to delete'#255'this files ?';
 End;

CancelSB;
if cquestion(s,lang) then
 begin
  if p.Insed=0 then p.trddir^[p.Index].mark:=true;
  Case p.PanelType of
   trdPanel: trdDel(p);
   fdiPanel: fdiDel(p);
   fddPanel: fddDel(p);
   sclPanel: sclDel(p);
   tapPanel: tapDel(p);
  End;
  reMDF;
  lp.TrueCur; lp.InSide;
  rp.TrueCur; rp.InSide;
  reInfo('cbdnsfi'); rePDF;
 end;
End;


{============================================================================}
Procedure snPacker(var p:TPanel);
var zpk,s:string; n,i:word; f:text; l1:byte;
Begin
if p.PanelType<>pcPanel then exit;
if (p.Insed=0)and(p.Index<=p.pctdirs) then exit;
if (p.Insed=1)and(p.FirstMarked<=p.pctdirs) then exit;

CancelSB;
Colour(bkdRama,txtdRama);
scPutWin(bkdRama,txtdRama,9,halfmaxy-7,72,halfmaxy+6);
if lang=rus then s:=' 娢஢ 䠩 '
            else s:=' Archive files ';
cmCentre(bkdRama,txtdRama,halfmaxy-7,s);
if lang=rus then s:=' '
            else s:='Archive to';
cmPrint(bkdLabelST,txtdLabelST,12,halfmaxy-5,s);
cmPrint(bkdInputNT,txtdInputNT,25,halfmaxy-5,space(45));
if lang=rus then s:='஫'
            else s:='Password';
cmPrint(bkdLabelNT,txtdLabelNT,13,halfmaxy-3,s);
cmPrint(bkdInputNT,txtdInputNT,12,halfmaxy-2,space(12));

if lang=rus then s:='. ⠭'
            else s:='Adv. settings';
cmPrint(bkdLabelNT,txtdLabelNT,29,halfmaxy-3,s);
cmPrint(bkdInputNT,txtdInputNT,28,halfmaxy-2,space(20));

if lang=rus then s:=' 娢'
            else s:='Archive type';
cmPrint(bkdLabelNT,txtdLabelNT,13,halfmaxy+0,s);
cmPrint(bkdPoleNT,txtdPoleNT,13,halfmaxy+1,'( ) ARJ  ');
cmPrint(bkdPoleNT,txtdPoleNT,22,halfmaxy+1,'( ) LHA  ');
cmPrint(bkdPoleNT,txtdPoleNT,31,halfmaxy+1,'( ) ZIP          ');
cmPrint(bkdPoleNT,txtdPoleNT,13,halfmaxy+2,'( ) HA   ');
cmPrint(bkdPoleNT,txtdPoleNT,22,halfmaxy+2,'( ) RAR  ');
cmPrint(bkdPoleNT,txtdPoleNT,31,halfmaxy+2,'('#7') ZXZIP        ');

if lang=rus then s:='[X]   '
            else s:='[X] Store path      ';
cmPrint(bkdPoleNT,txtdPoleNT,50,halfmaxy-3,s);
if lang=rus then s:='[ ] ७ 䠩'
            else s:='[ ] Move files      ';
cmPrint(bkdPoleNT,txtdPoleNT,50,halfmaxy-2,s);
if lang=rus then s:='⨥'
            else s:='Compress';
cmPrint(bkdLabelNT,txtdLabelNT,51,halfmaxy+0,s);
if lang=rus then s:='( ) ଠ쭮     '
            else s:='( ) Normal         ';
cmPrint(bkdPoleNT,txtdPoleNT,51,halfmaxy+1,s);
if lang=rus then s:='( ) ஥        '
            else s:='( ) Fast           ';
cmPrint(bkdPoleNT,txtdPoleNT,51,halfmaxy+2,s);
if lang=rus then s:='( ) ᨬ쭮   '
            else s:='('#7') Maximum        ';
cmPrint(bkdPoleNT,txtdPoleNT,51,halfmaxy+3,s);

cbutton(bkdButtonA,txtdButtonA,bkdButtonShadow,txtdButtonShadow,36,halfmaxy+4,'    OK    ',true);

if p.Insed=0 then s:=strhi(p.pcDir^[p.Index].fname);
if p.Insed=1 then s:=strhi(p.pcDir^[p.FirstMarked].fname);
if p.Insed>1 then s:=GetOf(strhi(ReverseStr(copy(ReverseStr(p.pcnd),2,pos('\',copy(ReverseStr(p.pcnd),2,255))-1))),_name);
if nospace(s)='' then s:='ZXARC';

Colour(bkdInputNT,txtdInputNT);
curon; s:=nospace(scanf(26,halfmaxy-5,s,43,43,1)); curoff; restscr;
if scanf_esc then exit;

getprofile(startdir+'\sn.ini','Spectrum','zxzipLine',zpk);
l1:=vall(nospace(zpk)); if l1<=0 then l1:=5;
getprofile(startdir+'\sn.ini','Spectrum','zxzip',zpk);
if p.Insed=0 then begin command:=command+p.TrueName(p.Index); n:=2; end else n:=1;


{$I-}
assign(f,p.pcnd+'$zxztmp$.bat'); filemode:=2; rewrite(f);
writeln(f,'@echo off');

i:=p.pctdirs+1;
repeat
 if p.pcDir^[i].mark then
  begin
   command:=command+p.TrueName(i)+' ';
   inc(n);
   if n>l1 then begin writeln(f,zpk+' '+s+' '+command); command:=''; n:=1;  end;
   p.pcDir^[i].mark:=false;
   p.Info('s');
   p.PDF;
  end;
 inc(i);
 if i>p.pctdirs+p.pctfiles then break;
until false;
{message(strr(n)+' '+zpk+' '+s+' '+command);{}
if n>1 then begin writeln(f,zpk+' '+s+' '+command); command:=''; end;

write(f,'del '+p.pcnd+'$zxztmp$.bat >nul');{}
close(f);
{$I+}
if IOResult=0 then
 begin
  command:=p.pcnd+'$zxztmp$.bat';
  DoExec(command,false);{}
 end
else
 begin
  if lang=rus then s:=' ᮧ ६ 䠩' else s:='Can'#39't create temp file';
  errormessage(s);
 end;
End;




{============================================================================}
Procedure zxViewFile(var p:TPanel);
var s:string;
{----------------------------------------------------------------------------}
function LoadFile:boolean;
Begin
Case p.PanelType of
 trdPanel: LoadFile:=trdLoad(p,p.Index);
 fdiPanel: LoadFile:=fdiLoad(p,p.Index);
 fddPanel: LoadFile:=fddLoad(p,p.Index);
 sclPanel: LoadFile:=sclLoad(p,p.Index);
 tapPanel: LoadFile:=tapLoad(p,p.Index);
End;
End;
{----------------------------------------------------------------------------}
function SaveFile(hh:boolean):boolean;
var ff:file; buf:array[1..17]of byte; tc,m:word;
Begin
SaveFile:=false;
{$I-}
assign(ff,tempdir+startnum); filemode:=2; rewrite(ff,1);
if hh then
 Begin
  for tc:=1 to 8 do buf[tc]:=ord(HobetaInfo.name[tc]);
  buf[9]:=ord(HobetaInfo.typ);
  m:=HobetaInfo.start; buf[10]:=lo(m); buf[11]:=hi(m);
  m:=HobetaInfo.length; buf[12]:=lo(m); buf[13]:=hi(m);
  buf[14]:=0; buf[15]:=HobetaInfo.totalsec;
  m:=0; for tc:=1 to 15 do m:=m+257*buf[tc]+(tc-1);
  buf[16]:=lo(m); buf[17]:=hi(m);
  blockwrite(ff,buf,17);
 End;
blockwrite(ff,HobetaInfo.body^,256*HobetaInfo.totalsec);
freeMem(HobetaInfo.body,256*HobetaInfo.totalsec);
close(ff);
{$I+}
m:=IOResult;
if m=0 then SaveFile:=true;
End;
{----------------------------------------------------------------------------}
procedure MainViewer(s:string);
var hhb:boolean;
begin
hhb:=false;
if pos('@HobetaBasic',s)<>0 then
 begin
  getprofile(startdir+'\sn.ini','View','HobetaBasic',s);
  s:=startdir+'\TOOLS\'+s;
 end;
if pos('@HobetaCode',s)<>0 then
 begin
  getprofile(startdir+'\sn.ini','View','HobetaCode',s);
  s:=startdir+'\TOOLS\'+s;
 end;
if pos('@HobetaScreen',s)<>0 then
 begin
  getprofile(startdir+'\sn.ini','View','HobetaScreen',s);
  s:=startdir+'\TOOLS\'+s;
 end;
if pos('@HobetaTrueScreen',s)<>0 then
 begin
  getprofile(startdir+'\sn.ini','View','HobetaTrueScreen',s);
  s:=startdir+'\TOOLS\'+s;
 end;
if pos('!',s)<>0 then begin delete(s,pos('!',s),1); hhb:=true; end;
if pos('*',s)<>0 then delete(s,pos('*',s)-1,2);
if LoadFile then if SaveFile(hhb) then
 Begin
  command:=s+' '+tempdir+startnum;
  DoExec(command,false);{}
 End;
end;
{----------------------------------------------------------------------------}
procedure ViewScr;
Begin
getprofile(startdir+'\sn.ini','View','HobetaScreen',s);
if nospace(s)<>'' then MainViewer(startdir+'\TOOLS\'+s);
End;
{----------------------------------------------------------------------------}
procedure ViewBasic;
Begin
getprofile(startdir+'\sn.ini','View','HobetaBasic',s);
if nospace(s)<>'' then MainViewer(startdir+'\TOOLS\'+s);
End;
{----------------------------------------------------------------------------}
procedure ViewCode;
Begin
getprofile(startdir+'\sn.ini','View','HobetaCode',s);
if nospace(s)<>'' then MainViewer(startdir+'\TOOLS\'+s);
End;
{----------------------------------------------------------------------------}
procedure ViewByExt;
var hhb:boolean;
Begin
getprofile(startdir+'\sn.ini','View',TRDOSe3(p,p.Index),s);
if nospace(s)<>'' then MainViewer(s);
End;
{----------------------------------------------------------------------------}
procedure ViewByLen;
Begin
getprofile(startdir+'\sn.ini','ViewByLength',strr(p.trdDir^[p.Index].length),s);
if nospace(s)<>'' then MainViewer(s);
End;
{----------------------------------------------------------------------------}
Begin
if p.PanelType=zxzPanel then exit;
if p.PanelType=tapPanel then
 Begin
  if p.trdDir^[p.Index].tapflag=0 then exit;
  if p.Index-1=1 then exit;
  if p.trdDir^[p.Index-1].tapflag=0 then
   Begin
    if AltF3Pressed then ViewScr;
    if p.trdDir^[p.Index-1].taptyp=0 then ViewBasic;
    ViewByExt;
    ViewByLen;
    if (p.trdDir^[p.Index-1].taptyp<>0) then ViewCode;
   End
  else
   Begin
    ViewByLen;
    ViewCode;
   End;
 End
else
 Begin
  if AltF3Pressed then ViewScr;
  if (TRDOSe3(p,p.Index)='<B>') then ViewBasic;
  ViewByExt;
  ViewByLen;
  if (TRDOSe3(p,p.Index)<>'<B>') then ViewCode;
 End;
End;




Begin
sBar[rus,trdPanel]:='~`Alt+X~` 室 ~` F3~` Cp ~` F5~`  ~` F6~` ६ ~` F7~`  ~` F8~`  ~` F9~` ⪠ ~`';
sBar[eng,trdPanel]:='~`Alt+X~` Exit ~` F3~` View ~` F5~` Copy ~` F6~` Rename ~` F7~` Move ~` F8~` Delete ~` F9~` Label ~`';
TRDOS3:=false;

End.