{$O+,F+}
Unit TRD_Ovr;
Interface
Uses
     Dos,Crt,RV,sn_Obj, Vars, Palette, Main, Main_Ovr,
     PC,PC_Ovr,TRD;
function  trdLoad(var p:TPanel; ind:word):boolean;
function  trdSave(var p:TPanel):boolean;
function  trdDel(var p:TPanel):boolean;
function  zxSNscanf(scanf_posx, scanf_posy:byte;scanf_str:string; t:char):string;
function  trdRename:boolean;
function  trdMove(var p:Tpanel):boolean;
procedure mtscanf(scanf_str,scanf_str2:string; var scanf_str_out,scanf_str2_out:string);
function  trdLabel:boolean;
procedure trdMakeImage(var p:TPanel);
procedure AltCPressed(var p:TPanel);
procedure AltPPressed(var p:TPanel);
procedure AltRPressed(var p:TPanel);
procedure AltLPressed(var p:TPanel);


Implementation


{============================================================================}
function  trdLoad(var p:TPanel; ind:word):boolean;
Var f:file;
Begin
HobetaInfo.name:=p.trdDir^[ind].name;
HobetaInfo.typ:=p.trdDir^[ind].typ;
HobetaInfo.start:=p.trdDir^[ind].start;
HobetaInfo.length:=p.trdDir^[ind].length;
HobetaInfo.param2:=p.trdDir^[ind].length{};
if HobetaInfo.typ<>'B' then HobetaInfo.param2:=32768;
HobetaInfo.totalsec:=p.trdDir^[ind].totalsec;

trdLoad:=false;
{$I-}
GetMem(HobetaInfo.body,256*HobetaInfo.totalsec);
assign(f,p.trdfile); filemode:=0; reset(f,1);
seek(f,bpos(p.trdDir^[ind].n1tr,p.trdDir^[ind].n1sec));
blockread(f,HobetaInfo.body^,256*HobetaInfo.totalsec);
close(f);
{$I+}
if ioresult=0 then trdLoad:=true else FreeMem(HobetaInfo.body,256*HobetaInfo.totalsec);
End;



{============================================================================}
function  trdSave(var p:TPanel):boolean;
Var f:file; i,b:byte; buf:array[0..15]of byte;
Begin
trdSave:=false;
{$I-}
assign(f,p.trdfile); filemode:=2; reset(f,1);

seek(f,bpos(p.zxDisk.nTr1FreeSec,p.zxDisk.n1FreeSec));
blockwrite(f,HobetaInfo.body^,256*HobetaInfo.totalsec);

inc(p.zxdisk.files);
dec(p.zxdisk.free,hobetainfo.totalsec);

p.trdDir^[p.zxdisk.files].name:=HobetaInfo.name;
p.trdDir^[p.zxdisk.files].typ:=HobetaInfo.typ;
p.trdDir^[p.zxdisk.files].start:=HobetaInfo.start;
p.trdDir^[p.zxdisk.files].length:=HobetaInfo.length;
p.trdDir^[p.zxdisk.files].totalsec:=HobetaInfo.totalsec;
p.trdDir^[p.zxdisk.files].n1tr:=p.zxDisk.nTr1FreeSec;
p.trdDir^[p.zxdisk.files].n1sec:=p.zxDisk.n1FreeSec;

for i:=1 to hobetainfo.totalsec do
 begin
  inc(p.zxdisk.n1freesec);
  if p.zxdisk.n1freesec>15 then begin p.zxdisk.n1freesec:=0; inc(p.zxdisk.ntr1freesec); end;
 end;

seek(f,$8e1); b:=p.zxdisk.n1freesec;   blockwrite(f,b,1);
seek(f,$8e2); b:=p.zxdisk.ntr1freesec; blockwrite(f,b,1);
seek(f,$8e4); b:=p.zxdisk.files;       blockwrite(f,b,1);
seek(f,$8e5); b:=lo(p.zxdisk.free);    blockwrite(f,b,1);
seek(f,$8e6); b:=hi(p.zxdisk.free);    blockwrite(f,b,1);

for i:=1 to 8 do buf[i-1]:=ord(p.trddir^[p.zxdisk.files].name[i]);
buf[8]:=ord(p.trddir^[p.zxdisk.files].typ);
buf[9]:=lo(p.trddir^[p.zxdisk.files].start);
buf[10]:=hi(p.trddir^[p.zxdisk.files].start);
buf[11]:=lo(p.trddir^[p.zxdisk.files].length);
buf[12]:=hi(p.trddir^[p.zxdisk.files].length);
buf[13]:=p.trddir^[p.zxdisk.files].totalsec;
buf[14]:=p.trddir^[p.zxdisk.files].n1sec;
buf[15]:=p.trddir^[p.zxdisk.files].n1tr;
seek(f,16*(p.zxdisk.files-1)); blockwrite(f,buf,16);

FreeMem(HobetaInfo.body,256*HobetaInfo.totalsec);
close(f);
{$I+}
if ioresult=0 then trdSave:=true;
End;



{============================================================================}
function trdDel(var p:TPanel):boolean;
type hbuft=array[0..15] of byte; var i,io:byte; hbuf:hbuft; fs:file;
begin
trdDel:=false;
  {$I-}
  assign(fs,p.trdfile); filemode:=2; reset(fs,1);

  for i:=1 to p.tfiles do if p.trddir^[i].mark then
   begin
    inc(p.zxdisk.delfiles); seek(fs,$8f4); blockwrite(fs,p.zxdisk.delfiles,1);
    p.trddir^[i].name[1]:=chr(ord('1')-48);
    for io:=1 to 8 do hbuf[io-1]:=ord(p.trddir^[i].name[io]);
    hbuf[8]:=ord(p.trddir^[i].typ);
    hbuf[9]:=lo(p.trddir^[i].start);
    hbuf[10]:=hi(p.trddir^[i].start);
    hbuf[11]:=lo(p.trddir^[i].length);
    hbuf[12]:=hi(p.trddir^[i].length);
    hbuf[13]:=p.trddir^[i].totalsec;
    hbuf[14]:=p.trddir^[i].n1sec;
    hbuf[15]:=p.trddir^[i].n1tr;
    seek(fs,16*(i-2)); blockwrite(fs,hbuf,16);
    p.trddir^[i].mark:=false;
   end;

  close(fs);
  {$I+}
  if ioresult=0 then trdDel:=true;
  if AutoMove then
   begin
    trdautomove:=true;
    trdMove(p);
    trdautomove:=false;
   end;
end;





{============================================================================}
function zxSNscanf(scanf_posx, scanf_posy:byte;scanf_str:string; t:char):string;
var
     scanf_kod:char;
     scanf_x:byte;
     scanf_str_old:string;
     out:byte;
label loop;
begin
scanf_esc:=false;
scanf_str_old:=scanf_str;
scanf_x:=1;
{scanf_str:=scanf_str+space(12-length(scanf_str));{}
loop:
mprint(scanf_posx,scanf_posy,scanf_str);
gotoxy(scanf_posx+scanf_x-1,scanf_posy);
scanf_kod:=readkey;
if (scanf_kod in[' '..#127])and(scanf_x<=length(scanf_str)) then
 begin
  scanf_str[scanf_x]:=scanf_kod;
  inc(scanf_x);
  if scanf_x=9 then inc(scanf_x);
  if scanf_x=10 then inc(scanf_x);
 end;
{if scanf_kod='.' then scanf_x:=11;{}

if scanf_kod=#0 then
 begin
  scanf_kod:=readkey;
  if scanf_kod=#77 then
   begin
    inc(scanf_x);
    if scanf_x=9 then inc(scanf_x);
    if (TRDOS3)and(t<>'B') then else if scanf_x=10 then inc(scanf_x);
   end;
  if scanf_kod=#75 then
   begin
    dec(scanf_x);
    if (TRDOS3)and(t<>'B') then else if scanf_x=10 then dec(scanf_x);
    if scanf_x=9 then dec(scanf_x);
   end;
  if scanf_kod=#80 then scanf_kod:=#13;
  if scanf_kod=#72 then scanf_kod:=#13;
 end;

{}
if scanf_kod=#27 then begin zxsnscanf:=scanf_str_old; scanf_esc:=true; exit; end;
if scanf_kod=#13 then begin zxsnscanf:=scanf_str; exit; end;


if scanf_x<1 then scanf_x:=1;
if (TRDOS3)and(t<>'B') then out:=12 else out:=11;
if scanf_x>out then begin scanf_x:=out; end;
goto loop;
end;





{============================================================================}
function  trdRename:boolean;
type hbuft=array[0..15] of byte;
var i,io:integer;
    stemp,s:string;
    fs:file;
    xc,yc,b:byte;
    hbuf:hbuft;
    p:TPanel;
label fin;
Begin
trdRename:=false;
Case focus of left:p:=lp; right:p:=rp; End;
if p.Index<=1 then exit;
CancelSB;
colour(bkCurNT,txtCurNT);
stemp:=p.trddir^[p.Index].name+'.'+TRDOSe3(p,p.Index);
s:=stemp;
GetCurXYOf(focus,xc,yc);
curon; SetCursor(400); stemp:=zxsnscanf(xc,yc,stemp,p.trddir^[p.Index].typ); curoff;
if not scanf_esc then
 begin
  {$I-}
  assign(fs,p.trdfile); filemode:=2; reset(fs,1);
  i:=p.Index;
  if (TRDOS3)and(p.trddir^[p.Index].typ<>'B') then p.trddir^[i].start:=256*ord(stemp[12])+ord(stemp[11]);
  if (s[1]=chr(ord('1')-48))or(s[1]=chr(ord('0')-48)) then
   if (stemp[1]<>chr(ord('1')-48))and(stemp[1]<>chr(ord('0')-48))
   then dec(p.zxdisk.delfiles);
  seek(fs,$8f4); b:=p.zxdisk.delfiles;  blockwrite(fs,b,1);
  for io:=1 to 8 do hbuf[io-1]:=ord(stemp[io]);
  if (TRDOS3)and(p.trddir^[p.Index].typ<>'B') then hbuf[8]:=ord(stemp[10]) else hbuf[8]:=ord(stemp[11]);
  hbuf[9]:=lo(p.trddir^[i].start);
  hbuf[10]:=hi(p.trddir^[i].start);
  hbuf[11]:=lo(p.trddir^[i].length);
  hbuf[12]:=hi(p.trddir^[i].length);
  hbuf[13]:=p.trddir^[i].totalsec;
  hbuf[14]:=p.trddir^[i].n1sec;
  hbuf[15]:=p.trddir^[i].n1tr;
  seek(fs,16*(i-2));
  blockwrite(fs,hbuf,16);
  close(fs);
  {$I+}
  if ioresult=0 then trdRename:=true;
 end;
fin:
reMDF; reInfo('cbdnsfi'); rePDF;
End;




{============================================================================}
function trdMove(var p:Tpanel):boolean;
type hbuft=array[1..2] of byte;
var fr,t:word;
    c,i,a,m:integer; fs:file; buf:^hbuft; nr,nw:word; hbuf:array[0..15] of byte;
    b:byte;
    stemp:string;
begin
trdMove:=false;
if p.zxdisk.delfiles=0 then exit;
CancelSB;
if lang=rus then stemp:=' 㯫⭨'#255'  ?'
            else stemp:='Do you wish to move'#255'this disk ?';
if not trdautomove then
if not cquestion(stemp,lang) then exit;
if checkdirfile(p.trdfile)<>0 then
 begin
  if lang=rus then errormessage('  䠩 '+strlo(getof(p.trdfile,_name))+'.trd')
  else errormessage('File '+strlo(getof(p.trdfile,_name))+'.trd not found');
  p.paneltype:=pcpanel;
  p.pcMDF(p.pcnd);
  p.truecur;
  p.inside;
  p.Info('cbdnsfi');
  p.pcPDF(p.pcfrom);
  exit;
 end;
p.trdMDFs(p.trdfile);
fr:=0; t:=0;
for i:=1 to p.trdtfiles do fr:=fr+p.trddir^[i].totalsec;
inc(fr,p.zxdisk.free);
for i:=1 to p.trdtfiles do
 if (ord(p.trddir^[i].name[1])<>1)and(ord(p.trddir^[i].name[1])<>0) then
  t:=t+p.trddir^[i].totalsec;
  p.zxdisk.free:=fr-t;

  for i:=1 to p.trdtfiles do
   if (ord(p.trddir^[i].name[1])=1)or(ord(p.trddir^[i].name[1])=0) then break;
  p.zxdisk.n1freesec:=p.trddir^[i].n1sec;
  p.zxdisk.ntr1freesec:=p.trddir^[i].n1tr;
  for c:=i to p.trdtfiles do
   if (ord(p.trddir^[c].name[1])<>1)and(ord(p.trddir^[c].name[1])<>0) then break;
  {$I-}
  assign(fs,p.trdfile); filemode:=2; reset(fs,1);

  for a:=c to p.trdtfiles do
  if (ord(p.trddir^[a].name[1])<>1)and(ord(p.trddir^[a].name[1])<>0) then
   begin
    getmem(buf,p.trddir^[a].totalsec*256);
    seek(fs,bpos(p.trddir^[a].n1tr,p.trddir^[a].n1sec));
    blockread(fs,buf^,p.trddir^[a].totalsec*256,nr);
    seek(fs,bpos(p.zxdisk.ntr1freesec,p.zxdisk.n1freesec));
    blockwrite(fs,buf^,nr,nw);
    freemem(buf,p.trddir^[a].totalsec*256);

    p.trddir^[i].n1tr:=p.zxdisk.ntr1freesec;
    p.trddir^[i].n1sec:=p.zxdisk.n1freesec;
    p.trddir^[i].name:=p.trddir^[a].name;
    p.trddir^[i].typ:=p.trddir^[a].typ;
    p.trddir^[i].start:=p.trddir^[a].start;
    p.trddir^[i].length:=p.trddir^[a].length;
    p.trddir^[i].totalsec:=p.trddir^[a].totalsec;
    for m:=1 to p.trddir^[a].totalsec do
     begin
      inc(p.zxdisk.n1freesec);
      if p.zxdisk.n1freesec>15 then begin p.zxdisk.n1freesec:=0; inc(p.zxdisk.ntr1freesec); end;
     end;

    for m:=1 to 8 do hbuf[m-1]:=ord(p.trddir^[i].name[m]);
    hbuf[8]:=ord(p.trddir^[i].typ);
    hbuf[9]:=lo(p.trddir^[i].start);
    hbuf[10]:=hi(p.trddir^[i].start);
    hbuf[11]:=lo(p.trddir^[i].length);
    hbuf[12]:=hi(p.trddir^[i].length);
    hbuf[13]:=p.trddir^[i].totalsec;
    hbuf[14]:=p.trddir^[i].n1sec;
    hbuf[15]:=p.trddir^[i].n1tr;
    seek(fs,16*(i-2)); blockwrite(fs,hbuf,16);

    inc(i);
   end;
  for m:=i-1 to 128 do begin seek(fs,16*(m-1)); b:=0; blockwrite(fs,b,1); end;
  seek(fs,$8e1); b:=p.zxdisk.n1freesec;   blockwrite(fs,b,1);
  seek(fs,$8e2); b:=p.zxdisk.ntr1freesec; blockwrite(fs,b,1);
  seek(fs,$8e4); b:=i-2;                  blockwrite(fs,b,1);
  seek(fs,$8f4); b:=0;                    blockwrite(fs,b,1);

  seek(fs,$8e5); b:=lo(p.zxdisk.free);    blockwrite(fs,b,1);
  seek(fs,$8e6); b:=hi(p.zxdisk.free);    blockwrite(fs,b,1);

  close(fs);
  {$I+}
if ioresult=0 then trdMove:=true;

p.trdMDFs(p.trdfile);
if trdAutoMove then exit;
p.TrueCur; p.Inside;
reInfo('cbdnsfi');
rePDF;
end;



{============================================================================}
function trdLabel:boolean;
var s:string; fs:file of byte; b:byte; p:TPanel;
label fin;
begin
trdLabel:=false; Case focus of left:p:=lp; right:p:=rp; End;
CancelSB; colour(bkCurST,txtCurST);
s:=p.zxdisk.disklabel;
curon;
Case focus of left:s:=scanf(17,1,s,8,8,1); right:s:=scanf(57,1,s,8,8,1); End;
curoff;
if not scanf_esc then
 begin
  {$I-}
  assign(fs,p.trdfile); filemode:=2; reset(fs);
  seek(fs,$8f5); for i:=1 to 8 do begin b:=ord(s[i]); write(fs,b); end;
  close(fs);
  {$I+}
  if ioresult=0 then trdLabel:=true;
  reMDF; rePDF;
 end;
fin:
reInfo('cbdnsfi');
end;





{============================================================================}
procedure mtscanf(scanf_str,scanf_str2:string; var scanf_str_out,scanf_str2_out:string);
var
     scanf_kod:char;
     scanf_x, scanf_x2:byte;
     scanf_total,scanf_total2, scanf_visible,scanf_visible2:byte;
     scanf_str_old:string;
label loop,loop2;
begin
scanf_esc:=false;
scanf_total:=8; scanf_total2:=3;
scanf_visible:=8; scanf_visible2:=3;
scanf_str:=scanf_str+space(scanf_total-length(scanf_str));{}
scanf_str2:=scanf_str2+space(scanf_total2-length(scanf_str2));{}
scanf_x:=1; scanf_x2:=1;
if scanf_visible>length(scanf_str) then scanf_visible:=length(scanf_str);

loop:
mprint(42,halfmaxy-2,scanf_str);
mprint(47,halfmaxy-0,scanf_str2);
gotoxy(42+scanf_x-1,halfmaxy-2);
scanf_kod:=readkey;
if scanf_kod=#27 then begin scanf_esc:=true; exit; end;
if scanf_kod=#13 then
 begin
  if (vall(nospace(scanf_str2))=40)or
     ((vall(nospace(scanf_str2))>=80)and(vall(nospace(scanf_str2))<=128)) then
   begin
    scanf_str_out:=scanf_str; scanf_str2_out:=scanf_str2;
    exit;
   end
  else
   begin
    scanf_str2:=nospace(scanf_str2);
    if (vall(scanf_str2)>=0)and(vall(scanf_str2)<=40) then scanf_str2:='40';
    if (vall(scanf_str2)>=41)and(vall(scanf_str2)<=80) then scanf_str2:='80';
    if vall(scanf_str2)>128 then scanf_str2:='128';
    scanf_str2:=scanf_str2+space(scanf_total2-length(scanf_str2));{}
   end;
 end;

if ((scanf_kod)>=' ')and((scanf_kod)<='')and(scanf_x<=length(scanf_str)) then
 begin
  scanf_str:=copy(scanf_str,1,scanf_x-1)+scanf_kod+copy(scanf_str,scanf_x,length(scanf_str));
  scanf_str:=copy(scanf_str,1,length(scanf_str)-1);
  inc(scanf_x);
  if scanf_x>length(scanf_str)+1 then scanf_x:=length(scanf_str)+1;
 end;

if scanf_kod=#8 then
 begin
  scanf_str:=copy(scanf_str,1,scanf_x-2)+copy(scanf_str,scanf_x,length(scanf_str));
  dec(scanf_x);
  if scanf_x<1 then scanf_x:=1 else scanf_str:=scanf_str+' ';
  if scanf_x<1 then scanf_x:=1;
 end;

if scanf_kod=#9 then
 begin
loop2:
  mprint(42,halfmaxy-2,scanf_str);
  mprint(47,halfmaxy-0,scanf_str2);
  gotoxy(47+scanf_x2-1,halfmaxy-0);
  scanf_kod:=readkey;
  if scanf_kod=#9 then goto loop;
  if scanf_kod=#13 then
   begin
    if (vall(nospace(scanf_str2))=0)or
       (vall(nospace(scanf_str2))=40)or
       ((vall(nospace(scanf_str2))>=80)and(vall(nospace(scanf_str2))<=128)) then
     begin
      scanf_str_out:=scanf_str; scanf_str2_out:=scanf_str2;
      exit;
     end
    else
     begin
      scanf_str2:=nospace(scanf_str2);
      if (vall(scanf_str2)>0)and(vall(scanf_str2)<=40) then scanf_str2:='40';
      if (vall(scanf_str2)>=41)and(vall(scanf_str2)<=80) then scanf_str2:='80';
      if vall(scanf_str2)>128 then scanf_str2:='128';
      scanf_str2:=scanf_str2+space(scanf_total2-length(scanf_str2));{}
     end;
   end;
  if scanf_kod=#27 then begin scanf_esc:=true; exit; end;
  if scanf_kod=#8 then
   begin
    scanf_str2:=copy(scanf_str2,1,scanf_x2-2)+copy(scanf_str2,scanf_x2,length(scanf_str2));
    dec(scanf_x2);
    if scanf_x2<1 then scanf_x2:=1 else scanf_str2:=scanf_str2+' ';
    if scanf_x2<1 then scanf_x2:=1;
   end;
  if (scanf_kod in['1'..'9','0',' '])and(scanf_x2<=length(scanf_str2)) then
   begin
    scanf_str2[scanf_x2]:=scanf_kod;
    inc(scanf_x2);
    if scanf_x2>length(scanf_str2)+1 then scanf_x2:=length(scanf_str2)+1;
   end;
  if scanf_kod=#0 then
   begin
    scanf_kod:=readkey;
    if scanf_kod=#71 then begin scanf_x2:=1; end;
    if scanf_kod=#79 then begin scanf_x2:=length(scanf_str2); end;
    if scanf_kod=#83 then scanf_str2:=copy(scanf_str2,1,scanf_x2-1)+copy(scanf_str2,scanf_x2+1,length(scanf_str2))+' ';
    if scanf_kod=#77 then inc(scanf_x2);
    if scanf_kod=#75 then dec(scanf_x2);
    if scanf_x2<1 then scanf_x2:=1;
    if scanf_x2>length(scanf_str2)+1 then begin scanf_x2:=length(scanf_str2)+1; end;
   end;

  goto loop2;
 end;

if scanf_kod=#25 then
 begin
  scanf_str:=space(scanf_total);
  scanf_x:=1;
 end;

if scanf_kod=#0 then
 begin
  scanf_kod:=readkey;
  if scanf_kod=#71 then begin scanf_x:=1; end;
  if scanf_kod=#79 then begin scanf_x:=length(scanf_str); end;
  if scanf_kod=#83 then scanf_str:=copy(scanf_str,1,scanf_x-1)+copy(scanf_str,scanf_x+1,length(scanf_str))+' ';
  if scanf_kod=#77 then inc(scanf_x);
  if scanf_kod=#75 then dec(scanf_x);
  if scanf_x<1 then scanf_x:=1;
  if scanf_x>length(scanf_str)+1 then begin scanf_x:=length(scanf_str)+1; end;
 end;

goto loop;
end;



{============================================================================}
procedure trdMakeImage(var p:TPanel);
var name:string; stemp,tr:string;
    buf:array[1..8192] of byte;
    i:word;
    ff:file;
    fb:file of byte;
    ft:text;
    b:byte;
begin
 CancelSB;
 colour(bkdRama,txtdRama);
 scputwin(bkdRama,txtdRama,27,halfmaxy-4,54,halfmaxy+2);
 if makeboot
  then if lang=rus then cmcentre(bkdRama,txtdRama,halfmaxy-4,'  TRD-䠩 + boot ')
                   else cmcentre(bkdRama,txtdRama,halfmaxy-4,' New TRD-file + boot ')
  else if lang=rus then cmcentre(bkdRama,txtdRama,halfmaxy-4,'  TRD-䠩 ')
                   else cmcentre(bkdRama,txtdRama,halfmaxy-4,' New TRD-file ');

 if lang=rus then cmprint(bkdLabelST,txtdLabelST,31,halfmaxy-2,' 䠩:')
 else cmprint(bkdLabelST,txtdLabelST,31,halfmaxy-2,'File name:');
 if lang=rus then cmprint(bkdLabelST,txtdLabelST,31,halfmaxy-0,'- ஦:')
 else cmprint(bkdLabelST,txtdLabelST,31,halfmaxy-0,'Tracks on disk:');
 printself(bkdInputNT,txtdInputNT,42,halfmaxy-2,8);
 printself(bkdInputNT,txtdInputNT,47,halfmaxy-0,3);
 colour(bkdInputNT,txtdInputNT);
 curon;
 mtscanf('','80',name,tr);
 curoff;
 restscr;

name:=nospace(name); tr:=nospace(tr);
if (name='com1')or(name='com2')or(name='com3')or(name='com4')or
   (name='lpt1')or(name='lpt2')or(name='lpt3')or(name='lpt4')or
   (name='con')or(name='nul')or(name='prn')or(name='aux') then
    begin if lang=rus then errormessage('訡  ᮧ TRD-䠩')
    else errormessage('Error while create TRD-file'); exit; end;

if scanf_esc then exit;
if nospace(name)<>'' then
 begin
 {$I-}
  if lang=rus then stemp:=' '+getof(name,_name)+'.trd'+' 㦥 .'+#255+'  ?'
              else stemp:='File '+getof(name,_name)+'.trd'+' alredy exist.'+#255+' Overwrite?';
  if checkdirfile(p.pcnd+getof(name,_name)+'.trd')=0 then
   if not cquestion(stemp,lang) then exit;
  filemode:=2;
  p.pcnn:=getof(name,_name)+'.trd';
assign(ff,p.pcnd+getof(name,_name)+'.trd'); rewrite(ff,1);
  for i:=1 to sizeof(buf) do buf[i]:=0;
  if vall(tr)=0 then blockwrite(ff,buf,4096) else
  for i:=1 to vall(tr) do blockwrite(ff,buf,sizeof(buf));
  close(ff);

  if vall(tr)=0 then tr:='80';
  i:=(vall(tr)*2-1)*16;
  assign(fb,p.pcnd+getof(name,_name)+'.trd'); reset(fb);
  seek(fb,$8e1); b:=0; write(fb,b);
  seek(fb,$8e2); b:=1; write(fb,b);
  seek(fb,$8e3); if vall(nospace(tr))=40 then b:=$17 else b:=$16; write(fb,b);
  seek(fb,$8e4); b:=0; write(fb,b);
  seek(fb,$8e5); b:=lo(i); write(fb,b);
  seek(fb,$8e6); b:=hi(i); write(fb,b);
  seek(fb,$8e7); b:=$10; write(fb,b);
  seek(fb,$8ea); b:=32; for i:=0 to 9 do write(fb,b);
  seek(fb,$8f4); b:=0; write(fb,b);
  name:=name+space(8-length(name));
  seek(fb,$8f5);
  for i:=0 to 7 do begin b:=byte(name[i+1]); write(fb,b); end;

  seek(fb,$801);
  stemp:='ZX Spectrum Navigator  Version '+ver+'  Copyright (c) 1997,98 RomanRoms Software Co.  ';
  for i:=1 to length(stemp) do begin b:=byte(stemp[i]); write(fb,b); end;
  stemp:='Russia. Nizhny Novgorod.  Written by Roman Khroupnin (RomanRom2)  ';
  for i:=1 to length(stemp) do begin b:=byte(stemp[i]); write(fb,b); end;
  stemp:='To find me use FIDOnet - 2:5015/97 or Internet - RomanRom2@usa.net';
  for i:=1 to length(stemp) do begin b:=byte(stemp[i]); write(fb,b); end;

  close(fb);
  {$I+}
  i:=ioresult;
  if i<>0 then if lang=rus then errormessage('訡 '+strr(i)+'  ᮧ TRD-䠩')
                           else errormessage('Error '+strr(i)+' while create TRD-file');
 end;

  if (makeboot)and(checkdirfile(startdir+'\boots\boots.ini')=0){} then
   begin
    assign(ft,startdir+'\boots\boots.ini'); filemode:=0; reset(ft);
    b:=0;
    while not EOF(ft) do
     begin
      readln(ft,stemp);
      if length(stemp)>60 then stemp:=copy(stemp,1,60);
      if nospace(stemp)<>'' then inc(b); menu_name[b]:=stemp;
     end;
    close(ft);
    menu_total:=b;
    menu_title:='';
    menu_f:=1;
    if b<>0 then
     begin
      i:=chooseitem;
      if i<>0 then
       begin
        stemp:=menu_name[i];
        delete(stemp,pos(' ',stemp),255);
        if ithobeta(startdir+'\boots\'+stemp,hobetainfo)
         then
          begin
           p.trdfile:=p.pcnd+getof(name,_name)+'.trd';
           p.trdMDFs(p.trdfile);
           if hobetainfo.totalsec>p.zxdisk.free then
           if lang=rus then errormessage('H c  c  boot.<B>')
                       else errormessage('Not enough space for boot.<B>')
           else Begin hobLoad(startdir+'\boots\'+stemp); trdSave(p); End;
          end;
       end;
     end;
   end;

makeboot:=false;
end;




{============================================================================}
procedure AltCPressed(var p:TPanel);
type
    tmas=array[1..1] of byte;
var
    ff:file; fb:file of byte;
    buf:^tmas;
    nw,m:word;
    rest:integer;
    stemp:string;
    l:longint; b1,b:byte;

begin
if istrd(p.pcnd+p.pcnn) then
 begin
  CancelSB;
  if lang=rus then stemp:='㭪: TRD clean'#255'㫨 c㥬 cp?'
              else stemp:='Function: TRD clean'#255'Do you wish zero not used sectors?';
  if cquestion(stemp,lang) then
   begin
    trdMove(p);
{$I-}
    assign(fb,p.pcnd+p.pcnn); filemode:=2; reset(fb);
    seek(fb,$8e1); read(fb,b); p.zxdisk.n1FreeSec:=b;
    seek(fb,$8e2); read(fb,b); p.zxdisk.ntr1FreeSec:=b;
    seek(fb,$8e5); read(fb,b1);
    seek(fb,$8e6); read(fb,b); p.zxdisk.free:=b1+256*b;
    close(fb);

    rest:=p.zxdisk.free;

    getmem(buf,65280);
    for m:=1 to 65280 do buf^[m]:=0;
    assign(ff,p.pcnd+p.pcnn); filemode:=2; reset(ff,1);
    seek(ff,bpos(p.zxdisk.nTr1freeSec,p.zxdisk.n1freeSec));

    for m:=1 to (rest div 255) do blockwrite(ff,buf^,65280);
    freemem(buf,65280);

    nw:=rest-255*(rest div 255);
    getmem(buf,256*nw);
    for m:=1 to 256*nw do buf^[m]:=0;
    blockwrite(ff,buf^,256*nw);
    freemem(buf,256*nw);

    nw:=16*(128-p.zxdisk.files);
    getmem(buf,nw);
    for m:=1 to nw do buf^[m]:=0;
    seek(ff,(16*p.zxdisk.files));
    blockwrite(ff,buf^,nw);
    freemem(buf,nw);
    close(ff);
{$I+}
    if ioresult<>0 then;

    reMDF;
    p.TrueCur; p.Inside;{}
    reInfo('cbdnsfi');
    rePDF;
   end;
 end;
end;




{============================================================================}
procedure AltPPressed(var p:TPanel);
var ff:file of byte; stemp:string;
begin

if istrd(p.pcnd+p.pcnn) then
 begin
  CancelSB;
  if lang=rus then stemp:='㭪: TRD pack'#255' c㥬 cp?'
              else stemp:='Function: TRD pack'#255'Do you wish remove not used sectors?';
  if cquestion(stemp,lang) then
   begin
    p.trdfile:=p.pcnd+p.pcnn;
    trdautomove:=true;
    trdMove(p);
    trdautomove:=AutoMove;
{$I-}
    assign(ff,p.pcnd+p.pcnn); filemode:=2; reset(ff);

seek(ff,$8e1); read(ff,p.zxdisk.n1freesec);
seek(ff,$8e2); read(ff,p.zxdisk.ntr1freesec);

    seek(ff,bpos(p.zxdisk.nTr1freeSec,p.zxdisk.n1freeSec));
    truncate(ff);
    close(ff);
{$I+}
    if ioresult<>0 then;
    reMDF;
    p.TrueCur; p.Inside;{}
    reInfo('cbdnsfi');
    rePDF;
   end;
 end;
end;





{============================================================================}
procedure AltRPressed(var p:TPanel);
type
    tbuf=array[1..1] of byte;
var
    a,b,i:integer; ss,t:string;
    buf:^tbuf;
    ff:file;
    hbuf:array[1..17] of byte;
    nr,nw:word;
    h:byte;
begin
case p.paneltype of
 pcPanel:
   begin
    if p.pcfrom+p.pcf-1<=p.pctdirs then exit;
    ss:=p.pcnd+p.pcdir^[p.pcfrom+p.pcf-1].fname+'.'+p.pcdir^[p.pcfrom+p.pcf-1].fext;
    if ss[length(ss)]='.' then delete(ss,length(ss),1);
    if ithobeta(ss,hobetainfo) then
     begin
      if lang=rus then t:='㭪: Remove HOBETA Header'#255'p?'
                  else t:='Function: Remove HOBETA Header'#255'Continue?';
      if not cquestion(t,lang) then exit;
{$I-}
      getmem(buf,p.pcdir^[p.pcfrom+p.pcf-1].flength);
      assign(ff,ss); filemode:=2; reset(ff,1); seek(ff,17);
      blockread(ff,buf^,p.pcdir^[p.pcfrom+p.pcf-1].flength,nr);
      seek(ff,0);
      blockwrite(ff,buf^,nr,nw);
      if hobetainfo.typ='B' then seek(ff,hobetainfo.length+4) else seek(ff,hobetainfo.length);
      truncate(ff);
      close(ff);
      if TRDOS3
        then t:=getof(ss,_name)+'.'+hobetainfo.typ+chr(lo(hobetainfo.start))+chr(hi(hobetainfo.start))
        else
         begin
          t:=getof(ss,_name)+nospace(getof(ss,_ext)+'!');
          if hobetainfo.length=6912 then t:=getof(ss,_name)+'.scr';
          if hobetainfo.length=18432 then t:=getof(ss,_name)+'.xpc';
          if (hobetainfo.typ='Z')and(hobetainfo.start=20553) then t:=getof(ss,_name)+'.zxz';
         end;
      rename(ff,p.pcnd+t);
      freemem(buf,p.pcdir^[p.pcfrom+p.pcf-1].flength);
{$I+}
      if ioresult<>0 then;
      p.pcnn:=strlo(nospace(t));

      reMDF;
      p.TrueCur; p.Inside;{}
      reInfo('cbdnsfi');
      rePDF;
     end
    else
     begin
      if p.pcdir^[p.pcfrom+p.pcf-1].flength<=65280 then
       begin
        if lang=rus then t:='㭪: Add HOBETA Header'#255'p?'
                    else t:='Function: Add HOBETA Header'#255'Continue?';
        if not cquestion(t,lang) then exit;
{$I-}
        hbuf[15]:=p.pcdir^[p.pcfrom+p.pcf-1].flength div 256;
        if 256*hbuf[15]<lp.pcdir^[p.pcfrom+p.pcf-1].flength then inc(hbuf[15]);

        getmem(buf,256*hbuf[15]); for nr:=1 to 256*hbuf[15] do buf^[nr]:=0;
        assign(ff,ss); filemode:=2; reset(ff,1);
        blockread(ff,buf^,p.pcdir^[p.pcfrom+p.pcf-1].flength,nr);
        close(ff); erase(ff);

        t:=strlo(p.pcdir^[p.pcfrom+p.pcf-1].fname); t:=t+space(8-length(t));
        for b:=1 to 8 do hbuf[b]:=ord(t[b]);
         if TRDOS3 then
          begin
           hbuf[9]:=ord(dncase(p.pcdir^[p.pcfrom+p.pcf-1].fext[1]));
           hbuf[10]:=ord(dncase(p.pcdir^[p.pcfrom+p.pcf-1].fext[2]));
           hbuf[11]:=ord(dncase(p.pcdir^[p.pcfrom+p.pcf-1].fext[3]));
          end
         else
          begin
           hbuf[9]:=ord('C');
           hbuf[10]:=lo(HobetaStartAddr);
           hbuf[11]:=hi(HobetaStartAddr);
           if p.pcDir^[p.Index].flength=6912 then
            begin
             hbuf[10]:=lo(16384);
             hbuf[11]:=hi(16384);
            end;
           if strlo(p.pcDir^[p.Index].fext)='zxz' then
            begin
             hbuf[9]:=ord('Z');
             hbuf[10]:=lo(20553);
             hbuf[11]:=hi(20553);
            end;
          end;
         hbuf[12]:=lo(p.pcdir^[p.pcfrom+p.pcf-1].flength);
         hbuf[13]:=hi(p.pcdir^[p.pcfrom+p.pcf-1].flength);
         hbuf[14]:=0;
         if (buf^[p.pcdir^[p.pcfrom+p.pcf-1].flength-3]=$80)and(buf^[p.pcdir^[p.pcfrom+p.pcf-1].flength-2]=$AA) then
          begin
           hbuf[9]:=ord('B');
           hbuf[10]:=lo(p.pcdir^[p.pcfrom+p.pcf-1].flength-4);
           hbuf[11]:=hi(p.pcdir^[p.pcfrom+p.pcf-1].flength-4);
           hbuf[12]:=lo(p.pcdir^[p.pcfrom+p.pcf-1].flength-4);
           hbuf[13]:=hi(p.pcdir^[p.pcfrom+p.pcf-1].flength-4);
          end;
         nw:=0; for b:=1 to 15 do nw:=nw+257*hbuf[b]+(b-1);
         hbuf[16]:=lo(nw);
         hbuf[17]:=hi(nw);

         if TRDOS3
          then t:=p.pcdir^[p.pcfrom+p.pcf-1].fname+'.$'+p.pcdir^[p.pcfrom+p.pcf-1].fext[1]
          else
           begin
            t:=p.pcdir^[p.pcfrom+p.pcf-1].fname+'.$c';
            if hbuf[9]=ord('Z') then t:=p.pcdir^[p.pcfrom+p.pcf-1].fname+'.$z';
            if hbuf[9]=ord('B') then t:=p.pcdir^[p.pcfrom+p.pcf-1].fname+'.$b';
           end;
         assign(ff,p.pcnd+t);
         filemode:=2; rewrite(ff,1);

         blockwrite(ff,hbuf,17,nw);{}
         blockwrite(ff,buf^,256*hbuf[15],nw);
{         seek(ff,256*hbuf[15]-1+17); h:=0; blockwrite(ff,h,1,nw);{}
         close(ff);
         freemem(buf,256*hbuf[15]);
{$I+}
         if ioresult<>0 then;
         p.pcnn:=strlo(nospace(t));

         reMDF;
         p.TrueCur; p.Inside;{}
         reInfo('cbdnsfi');
         rePDF;
     end;
   end;
end;
end;
end;




{============================================================================}
procedure AltLPressed(var p:TPanel);
var
    ff:text;
    i,m:byte;
    c,v:word;
    s:string;
    was:string;
    cur:boolean;
label fin;
{----------------------------------------------------------------------------}
procedure pl(var p:TPanel; i,m:byte);
begin
if m=1  then
writeln(ff,p.trddir^[i].name+'<'+p.trddir^[i].typ+'>'
        +' '+fill(3-length(strr(p.trddir^[i].totalsec)),'0')+strr(p.trddir^[i].totalsec)
        +' '+fill(5-length(strr(p.trddir^[i].start)),'0')+strr(p.trddir^[i].start)
        +' '+fill(5-length(strr(p.trddir^[i].length)),'0')+strr(p.trddir^[i].length)
        )
        else
writeln(ff,p.trddir^[i].name+'<'+p.trddir^[i].typ+'>');
end;
{----------------------------------------------------------------------------}
Begin
c:=0; for v:=p.pctdirs+1 to p.pctdirs+p.pctfiles do if p.pcdir^[v].mark then
 begin
  s:=nospace(p.pcdir^[v].fname+'.'+p.pcdir^[v].fext);
  if s[length(s)]='.' then s:=nospace(p.pcdir^[v].fname);
  if istrd(p.pcnd+s) then begin inc(c); p.pcdir^[v].mark:=true; end else p.pcdir^[v].mark:=false;
 end;
p.pcPDF(p.pcfrom); p.Info('si');

cur:=false;
if c=0 then if istrd(p.pcnd+p.pcnn) then begin p.pcdir^[p.pcfrom+p.pcf-1].mark:=true; inc(c); cur:=true; end;
if c=0 then goto fin else
 begin
  CancelSB; curoff;
  if lang=rus then
   begin
    menu_name[1]:='~`~` ';
    menu_name[2]:='~`~` ';
    menu_name[3]:='쪮 ~`~`ଠ ';
    menu_name[4]:='쪮 ~`B~`ASIC-䠩';
    menu_title:='㭪: TRD list';
   end
  else
   begin
    menu_name[1]:='~`F~`ull report';
    menu_name[2]:='B~`r~`ief report';
    menu_name[3]:='Inform~`a~`tion only';
    menu_name[4]:='~`B~`ASIC-files only';
    menu_title:='Function: TRD list';
   end;
  menu_total:=4; menu_f:=1; menu_visible:=255;
  m:=chooseitem;
 end;

was:=p.trdfile;
for v:=p.pctdirs+1 to p.pctdirs+p.pctfiles do if p.pcdir^[v].mark then
 BEGIN
  s:=nospace(p.pcdir^[v].fname+'.'+p.pcdir^[v].fext);
  if s[length(s)]='.' then s:=nospace(p.pcdir^[v].fname);
  if istrd(p.pcnd+s) then
   begin
    trdMDF(p,p.pcnd+s);
    if m<>0 then
     begin
{$I-}
      assign(ff,p.pcnd+getof(s,_name)+'.lst');
      filemode:=2; rewrite(ff);
      if (m=1)or(m=3) then
       begin
        writeln(ff,'Title: '+p.zxdisk.disklabel+'    Disk Drive: A');
        writeln(ff,strr(p.zxdisk.files)+' File(s)      80 Track D. Side');
        writeln(ff,strr(p.zxdisk.delfiles)+' Del. File(s)  Free Sector '+strr(p.zxdisk.free));
        writeln(ff,'');
       end;
      if (m=1) then writeln(ff,'  File Name    Start Length Line');
      for i:=2 to p.zxdisk.files+1 do
       begin
        if p.trddir^[i].typ='B' then if (m=1)or(m=2)or(m=4) then pl(p,i,m);
        if p.trddir^[i].typ<>'B' then if (m=1)or(m=2) then pl(p,i,m);
       end;
      close(ff);
      if ioresult<>0 then;
{$I+}
     end;
   end;
  if m<>0 then p.pcdir^[v].mark:=false;
  if m=0 then p.pcdir^[p.pcfrom+p.pcf-1].mark:=false;
 END;
p.trdfile:=was;
if checkdirfile(p.trdfile)=0 then p.trdMDFs(p.trdfile);

fin:

reMDF;
reTrueCur;
reInside;
reInfo('cbdnsfi');
rePDF;

end;












End.