Unit Palette;
Interface

Var
   bkSBarNT, txtSBarNT,
   bkSBarST, txtSBarST,

   BkSelectedNT, TxtSelectedNT,
   BkSelectedST, TxtSelectedST,

   BkCurNT, TxtCurNT,
   BkCurST, TxtCurST,

   BkNDActive, TxtNDActive,
   BkNDPassive, TxtNDPassive,

   BkNameLine, TxtNameLine,

   BkNT, TxtNT,
   BkST, TxtST,

   BkRama, TxtRama,

   BkCurLine, TxtCurLine,

   BkBP, TxtBP,

   BkFreeLineNT, TxtFreeLineNT,
   BkFreeLineST, TxtFreeLineST,

   bkDiskLineNT, txtDiskLineNT,
   bkDiskLineST, txtDiskLineST,
   bkDiskLineR, txtDiskLineR,


   BkDir, txtDir,
   bkArc, txtArc,
   bkExe, txtExe,

   bkG1, txtG1,
   bkG2, txtG2,
   bkG3, txtG3,
   bkG4, txtG4,
   bkG5, txtG5,

   bkdRama,txtdRama,
   bkdInputNT, txtdInputNT,
   bkdInputST, txtdInputST,
   bkdLabelNT, txtdLabelNT,
   bkdLabelST, txtdLabelST,
   bkdStatic,  txtdStatic,
   bkdButtonNA,txtdButtonNA,
   bkdButtonA, txtdButtonA,
   bkdButtonShadow,txtdButtonShadow,

   bkdPoleNT,  txtdPoleNT,
   bkdPoleST,  txtdPoleST,

   bkDiskInfoNT, txtDiskInfoNT,
   bkDiskInfoST, txtDiskInfoST,

   bkMenuNT,      txtMenuNT,
   bkMenuST,      txtMenuST,
   bkMenuMarkNT,  txtMenuMarkNT,
   bkMenuMarkST,  txtMenuMarkST


   :byte;


   group1: string;
   group2: string;
   group3: string;
   group4: string;
   group5: string;
   gexe: string;
   garc: string;


Procedure Col(ex:string; size:longint; var paper,ink:byte);
Procedure GetPalFile;{}

Implementation

uses crt,rv,clock,Vars;

procedure Col(ex:string; size:longint; var paper,ink:byte);
var s:string;
begin
ex:=';'+ex+';';
    if pos(ex,group1)<>0 then begin paper:=bkg1; ink:=txtg1; end;
    if pos(ex,group2)<>0 then begin paper:=bkg2; ink:=txtg2; end;
    if pos(ex,group3)<>0 then begin paper:=bkg3; ink:=txtg3; end;
    if pos(ex,group4)<>0 then begin paper:=bkg4; ink:=txtg4; end;
    if pos(ex,group5)<>0 then begin paper:=bkg5; ink:=txtg5; end;
    if pos(ex,gexe)<>0 then begin paper:=bkexe; ink:=txtexe; end;

    if ex=';>P<;' then begin paper:=bkexe; ink:=txtexe; end;
    if {(ex=';>C<;')and}(size=6912) then begin paper:=bkg5; ink:=txtg5; end;
    if (ex=';>B<;')and(size=6912) then begin paper:=bkg5; ink:=txtg5; end;

    if pos(ex,garc)<>0 then begin paper:=bkarc; ink:=txtarc; end;
    if strlo(ex)=';trd;' then begin paper:=bkdir; ink:=txtdir; end;
    if strlo(ex)=';tap;' then begin paper:=bkdir; ink:=txtdir; end;
    if strlo(ex)=';scl;' then begin paper:=bkdir; ink:=txtdir; end;{}
    if strlo(ex)=';fdi;' then begin paper:=bkdir; ink:=txtdir; end;
    if strlo(ex)=';fdd;' then begin paper:=bkdir; ink:=txtdir; end;
    if (strlo(ex)=';scr;')and(size=6912) then begin paper:=bkg5; ink:=txtg5; end;
    if (strlo(ex)=';xpc;')and(size=18432) then begin paper:=bkg5; ink:=txtg5; end;
    if (ex=';<C>;')and(size=6912) then begin paper:=bkg5; ink:=txtg5; end;
    if (ex=';<C>;')and(size=18432) then begin paper:=bkg5; ink:=txtg5; end;
    if (strlo(ex)=';$c;')and(size=6929) then begin paper:=bkg5; ink:=txtg5; end;
    if (strlo(ex)=';$c;')and(size=18449) then begin paper:=bkg5; ink:=txtg5; end;
end;

procedure GetPalFile;
var f:string; fb:file; b:byte; buf:array[0..512] of byte;
begin
 if checkdirfile(startdir+'\sn.ini')<>0 then exit;
 getprofile(startdir+'\sn.ini','Interface','Group1',f); group1:=f;
 getprofile(startdir+'\sn.ini','Interface','Group2',f); group2:=f;
 getprofile(startdir+'\sn.ini','Interface','Group3',f); group3:=f;
 getprofile(startdir+'\sn.ini','Interface','Group4',f); group4:=f;
 getprofile(startdir+'\sn.ini','Interface','Group5',f); group5:=f;
 getprofile(startdir+'\sn.ini','Interface','GroupExe',f); gexe:=f;
 getprofile(startdir+'\sn.ini','Interface','GroupArc',f); garc:=f;
 getprofile(startdir+'\sn.ini','Interface','PalleteFile',f);

 if nospace(f)='' then exit;
 if checkdirfile(startdir+'\colors\'+f)<>0 then exit;
 {$I-}
 assign(fb,startdir+'\colors\'+f); reset(fb,1); blockread(fb,buf,filesize(fb));

 b:=buf[$A5];
 bknameline:=b div 16; txtnameline:=b-(b div 16)*16;

 b:=buf[$55];
 bkNT:=b div 16; txtNT:=b-(b div 16)*16;

 b:=buf[$57];
 bkST:=b div 16; txtST:=b-(b div 16)*16;

 b:=buf[$57];
 bkST:=b div 16; txtST:=b-(b div 16)*16;

 b:=buf[$51];
 bkRama:=b div 16; txtRama:=b-(b div 16)*16;

 b:=buf[$77];
 bkCurLine:=b div 16; txtCurLine:=b-(b div 16)*16;

 b:=buf[$2];
 bkSBarNT:=b div 16; txtSBarNT:=b-(b div 16)*16;

 b:=buf[$4];
 bkSBarST:=b div 16; txtSBarST:=b-(b div 16)*16;

 b:=buf[$7C];
 bkFreeLineNT:=b div 16; txtFreeLineNT:=b-(b div 16)*16;

 b:=buf[$7D];
 bkFreeLineST:=b div 16; txtFreeLineST:=b-(b div 16)*16;

 b:=buf[$78];
 bkSelectedNT:=b div 16; txtSelectedNT:=b-(b div 16)*16;

 b:=buf[$79];
 bkSelectedST:=b div 16; txtSelectedST:=b-(b div 16)*16;

 b:=buf[$58];
 bkCurNT:=b div 16; txtCurNT:=b-(b div 16)*16;

 b:=buf[$59];
 bkCurST:=b div 16; txtCurST:=b-(b div 16)*16;

 b:=buf[$5A];
 bkNDActive:=b div 16; txtNDActive:=b-(b div 16)*16;

 b:=buf[$5B];
 bkNDPassive:=b div 16; txtNDPassive:=b-(b div 16)*16;

 b:=buf[$BA];
 bkDiskLineNT:=b div 16; txtDiskLineNT:=b-(b div 16)*16;

 b:=buf[$BC];
 bkDiskLineST:=b div 16; txtDiskLineST:=b-(b div 16)*16;

 b:=buf[$BB];
 bkDiskLineR:=b div 16; txtDiskLineR:=b-(b div 16)*16;

 b:=buf[$AC];
 bkDir:=b div 16; txtDir:=b-(b div 16)*16;

 b:=buf[$AD];
 bkExe:=b div 16; txtExe:=b-(b div 16)*16;

 b:=buf[$AE];
 bkArc:=b div 16; txtArc:=b-(b div 16)*16;

 b:=buf[$AF];
 bkg1:=b div 16; txtg1:=b-(b div 16)*16;

 b:=buf[$B0];
 bkg2:=b div 16; txtg2:=b-(b div 16)*16;

 b:=buf[$B1];
 bkg3:=b div 16; txtg3:=b-(b div 16)*16;

 b:=buf[$B4];
 bkg4:=b div 16; txtg4:=b-(b div 16)*16;

 b:=buf[$B5];
 bkg5:=b div 16; txtg5:=b-(b div 16)*16;

 b:=buf[$1];
 clcolour:=b;

 b:=buf[$21];
 bkdRama:=b div 16; txtdRama:=b-(b div 16)*16;

 b:=buf[$32];
 bkdInputNT:=b div 16; txtdInputNT:=b-(b div 16)*16;

 b:=buf[$33];
 bkdInputST:=b div 16; txtdInputST:=b-(b div 16)*16;

 b:=buf[$26];
 bkdLabelNT:=b div 16; txtdLabelNT:=b-(b div 16)*16;

 b:=buf[$27];
 bkdLabelST:=b div 16; txtdLabelST:=b-(b div 16)*16;

 b:=buf[$25];
 bkdStatic:=b div 16; txtdStatic:=b-(b div 16)*16;

 b:=buf[$29];
 bkdButtonNA:=b div 16; txtdButtonNA:=b-(b div 16)*16;

 b:=buf[$2B];
 bkdButtonA:=b div 16; txtdButtonA:=b-(b div 16)*16;

 b:=buf[$2E];
 bkdButtonShadow:=b div 16; txtdButtonShadow:=b-(b div 16)*16;

 b:=buf[$2F];
 bkdPoleNT:=b div 16; txtdPoleNT:=b-(b div 16)*16;

 b:=buf[$54];
 bkBP:=b div 16; txtBP:=b-(b div 16)*16;

 b:=buf[$30];
 bkdPoleST:=b div 16; txtdPoleST:=b-(b div 16)*16;

 b:=buf[$67];
 bkDiskInfoNT:=b div 16; txtDiskInfoNT:=b-(b div 16)*16;

 b:=buf[$66];
 bkDiskInfoST:=b div 16; txtDiskInfoST:=b-(b div 16)*16;

 b:=buf[$2];
 bkMenuNT:=b div 16; txtMenuNT:=b-(b div 16)*16;

 b:=buf[$5];
 bkMenuMarkNT:=b div 16; txtMenuMarkNT:=b-(b div 16)*16;

 b:=buf[$4];
 bkMenuST:=b div 16; txtMenuST:=b-(b div 16)*16;

 b:=buf[$7];
 bkMenuMarkST:=b div 16; txtMenuMarkST:=b-(b div 16)*16;

 close(fb);{}
 {$I+}
 if IOResult<>0 then;

end;
{}

Begin
bknameline:=1;     txtnameline:=yellow;

bkRama:=1;         txtRama:=11;

bkNT:=1;           txtNT:=lightcyan;
bkST:=1;           txtST:=yellow;

bkCurLine:=1;      txtCurLine:=lightcyan;

bkFreeLineNT:=1;      txtFreeLineNT:=11;
bkFreeLineST:=1;      txtFreeLineST:=14;

bkSBarNT:=3;          txtSBarNT:=0;
bkSBarST:=3;          txtSBarST:=14;

bkSelectedNT:=1;      txtSelectedNT:=14;
bkSelectedST:=1;      txtSelectedST:=14;

BkCurNT:=cyan;        txtCurNT:=0;
BkCurST:=cyan;        txtCurST:=yellow;

bkNDactive:=3;        txtNDactive:=0;
bkNDpassive:=1;       txtNDpassive:=11;

bkDiskLineNT:=1;      txtDiskLineNT:=11;
bkDiskLineST:=1;      txtDiskLineST:=14;
bkDiskLineR:=1;       txtDiskLineR:=11;


bkDir:=1;             txtDir:=11;
bkArc:=1;             txtArc:=11;
bkExe:=1;             txtExe:=11;

bkG1:=1;              txtG1:=11;
bkG2:=1;              txtG2:=11;
bkG3:=1;              txtG3:=11;
bkG4:=1;              txtG4:=11;
bkG5:=1;              txtG5:=11;

bkdRama:=7;           txtdRama:=0;
bkdInputNT:=3;        txtdInputNT:=0;
bkdInputST:=0;        txtdInputST:=3;
bkdLabelNT:=7;        txtdLabelNT:=0;
bkdLabelST:=7;        txtdLabelST:=0;
bkdStatic:=7;         txtdStatic:=0;
bkdButtonNA:=7;       txtdButtonNA:=0;
bkdButtonA:=3;        txtdButtonA:=0;
bkdButtonShadow:=7;   txtdButtonShadow:=0;

bkdPoleNT:=7;         txtdPoleNT:=0;
bkdPoleST:=7;         txtdPoleST:=15;

bkDiskInfoNT:=1;      txtDiskInfoNT:=11;
bkDiskInfoST:=1;      txtDiskInfoST:=14;

bkBP:=1;              txtBP:=11;

bkMenuNT:=7;          txtMenuNT:=0;
bkMenuST:=7;          txtMenuST:=15;
bkMenuMarkNT:=1;      txtMenuMarkNT:=11;
bkMenuMarkST:=1;      txtMenuMarkST:=15;


ClColour:=$1B;

group1:=';cpp;pas;c;asm;';
group2:=';.;doc;txt;ctl;diz;ini;cfg;!!!;lst;1st;';
group3:=';mod;mid;s3m;wav;voc;xm;stm;mpg;avi;mp3;';
group4:=';tmp;$$$;bak;';
group5:=';pcx;bmp;pic;gif;rle;ico;jpg;tga;';

gexe:=';exe;com;bat;';
garc:=';arj;zip;rar;lha;ha;arc;';
End.
